searchNodes=[{"doc":"AshAuthentication provides a turn-key authentication solution for folks using Ash . Usage This package assumes that you have Ash installed and configured. See the Ash documentation for details. Once installed you can easily add support for authentication by configuring the AshAuthentication extension on your resource: defmodule MyApp.Accounts.User do use Ash.Resource , extensions : [ AshAuthentication ] attributes do uuid_primary_key :id attribute :email , :ci_string , allow_nil? : false attribute :hashed_password , :string , allow_nil? : false , sensitive? : true end authentication do api MyApp.Accounts strategies do password :password do identity_field :email hashed_password_field :hashed_password end end end identities do identity :unique_email , [ :email ] end end If you plan on providing authentication via the web, then you will need to define a plug using AshAuthentication.Plug which builds a Plug.Router that routes incoming authentication requests to the correct provider and provides callbacks for you to manipulate the conn after success or failure. If you're using AshAuthentication with Phoenix, then check out ash_authentication_phoenix which provides route helpers, a controller abstraction and LiveView components for easy set up. Authentication Strategies Currently supported strategies: {{link:ash_authentication:module:AshAuthentication.Strategy.Password}} authenticate users against your local database using a unique identity (such as username or email address) and a password. {{link:ash_authentication:module:AshAuthentication.Strategy.OAuth2}} authenticate using local or remote OAuth 2.0 compatible services. Add-ons Add-ons are like strategies, except that they don't actually provide authentication - they just provide features adjacent to authentication. Current add-ons: {{link:ash_authentication:module:AshAuthentication.AddOn.Confirmation}} allows you to force the user to confirm changes using a confirmation token (eg. sending a confirmation email when a new user registers). Supervisor Some add-ons or strategies may require processes to be started which manage their state over the lifetime of the application (eg periodically deleting expired token revocations). Because of this you should add {AshAuthentication.Supervisor, otp_app: :my_app} to your application's supervision tree. See the Elixir docs for more information. DSL Documentation Index authentication tokens strategies password resettable oauth2 auth0 add_ons confirmation Docs authentication Configure authentication for this resource tokens strategies password resettable oauth2 auth0 add_ons confirmation :subject_name ( atom/0 ) - The subject name is used anywhere that a short version of your resource name is needed, eg: generating token claims, generating routes, form parameter nesting. This needs to be unique system-wide and if not set will be inferred from the resource name (ie MyApp.Accounts.User will have a subject name of user ). :api ( atom/0 ) - Required. The name of the Ash API to use to access this resource when doing anything authenticaiton related. :get_by_subject_action_name ( atom/0 ) - The name of the read action used to retrieve records. Used internally by AshAuthentication.subject_to_user/2 . If the action doesn't exist, one will be generated for you. The default value is :get_by_subject . tokens Configure JWT settings for this resource :enabled? ( boolean/0 ) - Should JWTs be generated by this resource? The default value is false . :store_all_tokens? ( boolean/0 ) - Store all tokens in the token_resource ? Some applications need to keep track of all tokens issued to any user. This is optional behaviour with ash_authentication in order to preserve as much performance as possible. The default value is false . :signing_algorithm ( String.t/0 ) - The algorithm to use for token signing. Available signing algorithms are; Ed448ph, Ed448, Ed25519ph, Ed25519, PS512, PS384, PS256, ES512, ES384, ES256, RS512, RS384, RS256, HS512, HS384 and HS256. The default value is &quot;HS256&quot; . :token_lifetime ( pos_integer/0 ) - How long a token should be valid, in hours. Since refresh tokens are not yet supported, you should probably set this to a reasonably long time to ensure a good user experience. Defaults to 14 days. The default value is 336 . :token_resource - Required. The resource used to store token information. If token generation is enabled for this resource, we need a place to store information about tokens, such as revocations and in-flight confirmations. :signing_secret - The secret used to sign tokens. Takes either a module which implements the AshAuthentication.Secret behaviour, a 2 arity anonymous function or a string. See the module documentation for AshAuthentication.Secret for more information. strategies Configure authentication strategies on this resource password resettable oauth2 auth0 password Strategy for authenticating using local resources as the source of truth. resettable Examples: password :password do identity_field :email hashed_password_field :hashed_password hash_provider AshAuthentication.BcryptProvider confirmation_required? true end :identity_field ( atom/0 ) - The name of the attribute which uniquely identifies the user. Usually something like username or email_address . The default value is :username . :hashed_password_field ( atom/0 ) - The name of the attribute within which to store the user's password once it has been hashed. The default value is :hashed_password . :hash_provider ( atom/0 ) - A module which implements the AshAuthentication.HashProvider behaviour. Used to provide cryptographic hashing of passwords. The default value is AshAuthentication.BcryptProvider . :confirmation_required? ( boolean/0 ) - Whether a password confirmation field is required when registering or changing passwords. The default value is true . :password_field ( atom/0 ) - The name of the argument used to collect the user's password in plaintext when registering, checking or changing passwords. The default value is :password . :password_confirmation_field ( atom/0 ) - The name of the argument used to confirm the user's password in plaintext when registering or changing passwords. The default value is :password_confirmation . :register_action_name ( atom/0 ) - The name to use for the register action. If not present it will be generated by prepending the strategy name with register_with_ . :sign_in_action_name ( atom/0 ) - The name to use for the sign in action. If not present it will be generated by prependign the strategy name with sign_in_with_ . resettable Configure password reset options for the resource :token_lifetime ( pos_integer/0 ) - How long should the reset token be valid, in hours. Defaults to 3 days. The default value is 72 . :request_password_reset_action_name ( atom/0 ) - The name to use for the action which generates a password reset token. If not present it will be generated by prepending the strategy name with request_password_reset_with_ . :password_reset_action_name ( atom/0 ) - The name to use for the action which actually resets the user's password. If not present it will be generated by prepending the strategy name with password_reset_with_ . :sender - Required. How to send the password reset instructions to the user. Allows you to glue sending of reset instructions to swoosh , ex_twilio or whatever notification system is appropriate for your application. Accepts a module, module and opts, or a function that takes a record, reset token and options. See AshAuthentication.Sender for more information. oauth2 OAuth2 authentication :client_id - Required. The OAuth2 client ID. Takes either a module which implements the AshAuthentication.Secret behaviour, a 2 arity anonymous function or a string. See the module documentation for AshAuthentication.Secret for more information. Example: client_id fn _ , resource -&gt; :my_app |&gt; Application . get_env ( resource , [ ] ) |&gt; Keyword . fetch ( :oauth_client_id ) end :site - Required. The base URL of the OAuth2 server - including the leading protocol (ie https:// ). Takes either a module which implements the AshAuthentication.Secret behaviour, a 2 arity anonymous function or a string. See the module documentation for AshAuthentication.Secret for more information. Example: site fn _ , resource -&gt; :my_app |&gt; Application . get_env ( resource , [ ] ) |&gt; Keyword . fetch ( :oauth_site ) end :auth_method - The authentication strategy used, optional. If not set, no authentication will be used during the access token request. The value may be one of the following: :client_secret_basic :client_secret_post :client_secret_jwt :private_key_jwt The default value is :client_secret_post . :client_secret - The OAuth2 client secret. Required if :auth_method is :client_secret_basic , :client_secret_post or :client_secret_jwt . Takes either a module which implements the AshAuthentication.Secret behaviour, a 2 arity anonymous function or a string. See the module documentation for AshAuthentication.Secret for more information. Example: site fn _ , resource -&gt; :my_app |&gt; Application . get_env ( resource , [ ] ) |&gt; Keyword . fetch ( :oauth_site ) end :authorize_path - The API path to the OAuth2 authorize endpoint. Relative to the value of site . If not set, it defaults to {:ok, &quot;/oauth/authorize&quot;} . Takes either a module which implements the AshAuthentication.Secret behaviour, a 2 arity anonymous function or a string. See the module documentation for AshAuthentication.Secret for more information. Example: authorize_path fn _ , _ -&gt; { :ok , &quot;/authorize&quot; } end :token_path - The API path to access the token endpoint. Relative to the value of site . If not set, it defaults to {:ok, &quot;/oauth/access_token&quot;} . Takes either a module which implements the AshAuthentication.Secret behaviour, a 2 arity anonymous function or a string. See the module documentation for AshAuthentication.Secret for more information. Example: token_path fn _ , _ -&gt; { :ok , &quot;/oauth_token&quot; } end :user_path - The API path to access the user endpoint. Relative to the value of site . If not set, it defaults to {:ok, &quot;/user&quot;} . Takes either a module which implements the AshAuthentication.Secret behaviour, a 2 arity anonymous function or a string. See the module documentation for AshAuthentication.Secret for more information. Example: user_path fn _ , _ -&gt; { :ok , &quot;/userinfo&quot; } end :private_key - The private key to use if :auth_method is :private_key_jwt Takes either a module which implements the AshAuthentication.Secret behaviour, a 2 arity anonymous function or a string. See the module documentation for AshAuthentication.Secret for more information. :redirect_uri - Required. The callback URI base. Not the whole URI back to the callback endpoint, but the URI to your AuthPlug . We can generate the rest. Whilst not particularly secret, it seemed prudent to allow this to be configured dynamically so that you can use different URIs for different environments. Takes either a module which implements the AshAuthentication.Secret behaviour, a 2 arity anonymous function or a string. See the module documentation for AshAuthentication.Secret for more information. :authorization_params ( keyword/0 ) - Any additional parameters to encode in the request phase. eg: authorization_params scope: &quot;openid profile email&quot; The default value is [] . :registration_enabled? ( boolean/0 ) - Is registration enabled for this provider? If this option is enabled, then new users will be able to register for your site when authenticating and not already present. If not, then only existing users will be able to authenticate. The default value is true . :register_action_name ( atom/0 ) - The name of the action to use to register a user. Only needed if registration_enabled? is true . Because we we don't know the response format of the server, you must implement your own registration action of the same name. See the &quot;Registration and Sign-in&quot; section of the module documentation for more information. The default is computed from the strategy name eg: register_with_\#{name} . :sign_in_action_name ( atom/0 ) - The name of the action to use to sign in an existing user. Only needed if registration_enabled? is false . Because we don't know the response format of the server, you must implement your own sign-in action of the same name. See the &quot;Registration and Sign-in&quot; section of the module documentation for more information. The default is computed from the strategy name, eg: sign_in_with_\#{name} . :identity_resource - The resource used to store user identities. Given that a user can be signed into multiple different authentication providers at once we use the AshAuthentication.UserIdentity resource to build a mapping between users, providers and that provider's uid. See the Identities section of the module documentation for more information. Set to false to disable. The default value is false . :identity_relationship_name ( atom/0 ) - Name of the relationship to the provider identities resource The default value is :identities . :identity_relationship_user_id_attribute ( atom/0 ) - The name of the destination (user_id) attribute on your provider identity resource. The only reason to change this would be if you changed the user_id_attribute_name option of the provider identity. The default value is :user_id . :name ( atom/0 ) - Required. Uniquely identifies the strategy. auth0 Auth0 authentication :client_id - Required. The OAuth2 client ID. Takes either a module which implements the AshAuthentication.Secret behaviour, a 2 arity anonymous function or a string. See the module documentation for AshAuthentication.Secret for more information. Example: client_id fn _ , resource -&gt; :my_app |&gt; Application . get_env ( resource , [ ] ) |&gt; Keyword . fetch ( :oauth_client_id ) end :site - Required. The base URL of the OAuth2 server - including the leading protocol (ie https:// ). Takes either a module which implements the AshAuthentication.Secret behaviour, a 2 arity anonymous function or a string. See the module documentation for AshAuthentication.Secret for more information. Example: site fn _ , resource -&gt; :my_app |&gt; Application . get_env ( resource , [ ] ) |&gt; Keyword . fetch ( :oauth_site ) end :auth_method - The authentication strategy used, optional. If not set, no authentication will be used during the access token request. The value may be one of the following: :client_secret_basic :client_secret_post :client_secret_jwt :private_key_jwt The default value is :client_secret_post . :client_secret - The OAuth2 client secret. Required if :auth_method is :client_secret_basic , :client_secret_post or :client_secret_jwt . Takes either a module which implements the AshAuthentication.Secret behaviour, a 2 arity anonymous function or a string. See the module documentation for AshAuthentication.Secret for more information. Example: site fn _ , resource -&gt; :my_app |&gt; Application . get_env ( resource , [ ] ) |&gt; Keyword . fetch ( :oauth_site ) end :authorize_path - The API path to the OAuth2 authorize endpoint. Relative to the value of site . If not set, it defaults to {:ok, &quot;/oauth/authorize&quot;} . Takes either a module which implements the AshAuthentication.Secret behaviour, a 2 arity anonymous function or a string. See the module documentation for AshAuthentication.Secret for more information. Example: authorize_path fn _ , _ -&gt; { :ok , &quot;/authorize&quot; } end :token_path - The API path to access the token endpoint. Relative to the value of site . If not set, it defaults to {:ok, &quot;/oauth/access_token&quot;} . Takes either a module which implements the AshAuthentication.Secret behaviour, a 2 arity anonymous function or a string. See the module documentation for AshAuthentication.Secret for more information. Example: token_path fn _ , _ -&gt; { :ok , &quot;/oauth_token&quot; } end :user_path - The API path to access the user endpoint. Relative to the value of site . If not set, it defaults to {:ok, &quot;/user&quot;} . Takes either a module which implements the AshAuthentication.Secret behaviour, a 2 arity anonymous function or a string. See the module documentation for AshAuthentication.Secret for more information. Example: user_path fn _ , _ -&gt; { :ok , &quot;/userinfo&quot; } end :private_key - The private key to use if :auth_method is :private_key_jwt Takes either a module which implements the AshAuthentication.Secret behaviour, a 2 arity anonymous function or a string. See the module documentation for AshAuthentication.Secret for more information. :redirect_uri - Required. The callback URI base. Not the whole URI back to the callback endpoint, but the URI to your AuthPlug . We can generate the rest. Whilst not particularly secret, it seemed prudent to allow this to be configured dynamically so that you can use different URIs for different environments. Takes either a module which implements the AshAuthentication.Secret behaviour, a 2 arity anonymous function or a string. See the module documentation for AshAuthentication.Secret for more information. :authorization_params ( keyword/0 ) - Any additional parameters to encode in the request phase. eg: authorization_params scope: &quot;openid profile email&quot; The default value is [] . :registration_enabled? ( boolean/0 ) - Is registration enabled for this provider? If this option is enabled, then new users will be able to register for your site when authenticating and not already present. If not, then only existing users will be able to authenticate. The default value is true . :register_action_name ( atom/0 ) - The name of the action to use to register a user. Only needed if registration_enabled? is true . Because we we don't know the response format of the server, you must implement your own registration action of the same name. See the &quot;Registration and Sign-in&quot; section of the module documentation for more information. The default is computed from the strategy name eg: register_with_\#{name} . :sign_in_action_name ( atom/0 ) - The name of the action to use to sign in an existing user. Only needed if registration_enabled? is false . Because we don't know the response format of the server, you must implement your own sign-in action of the same name. See the &quot;Registration and Sign-in&quot; section of the module documentation for more information. The default is computed from the strategy name, eg: sign_in_with_\#{name} . :identity_resource - The resource used to store user identities. Given that a user can be signed into multiple different authentication providers at once we use the AshAuthentication.UserIdentity resource to build a mapping between users, providers and that provider's uid. See the Identities section of the module documentation for more information. Set to false to disable. The default value is false . :identity_relationship_name ( atom/0 ) - Name of the relationship to the provider identities resource The default value is :identities . :identity_relationship_user_id_attribute ( atom/0 ) - The name of the destination (user_id) attribute on your provider identity resource. The only reason to change this would be if you changed the user_id_attribute_name option of the provider identity. The default value is :user_id . :name ( atom/0 ) - Required. Uniquely identifies the strategy. add_ons Additional add-ons related to, but not providing authentication confirmation confirmation User confirmation flow :token_lifetime ( pos_integer/0 ) - How long should the confirmation token be valid, in hours. Defaults to 3 days. The default value is 72 . :monitor_fields (list of atom/0 ) - Required. A list of fields to monitor for changes (eg [:email, :phone_number] ). The confirmation will only be sent when one of these fields are changed. :confirmed_at_field ( atom/0 ) - The name of a field to store the time that the last confirmation took place. This attribute will be dynamically added to the resource if not already present. The default value is :confirmed_at . :confirm_on_create? ( boolean/0 ) - Generate and send a confirmation token when a new resource is created? Will only trigger when a create action is executed and one of the monitored fields is being set. The default value is true . :confirm_on_update? ( boolean/0 ) - Generate and send a confirmation token when a resource is changed? Will only trigger when an update action is executed and one of the monitored fields is being set. The default value is true . :inhibit_updates? ( boolean/0 ) - Wait until confirmation is received before actually changing a monitored field? If a change to a monitored field is detected, then the change is stored in the token resource and the changeset updated to not make the requested change. When the token is confirmed, the change will be applied. This could be potentially weird for your users, but useful in the case of a user changing their email address or phone number where you want to verify that the new contact details are reachable. The default value is true . :sender - Required. How to send the confirmation instructions to the user. Allows you to glue sending of confirmation instructions to swoosh , ex_twilio or whatever notification system is appropriate for your application. Accepts a module, module and opts, or a function that takes a record, reset token and options. See AshAuthentication.Sender for more information. :confirm_action_name ( atom/0 ) - The name of the action to use when performing confirmation. If this action is not already present on the resource, it will be created for you. The default value is :confirm . :name ( atom/0 ) - Required. Uniquely identifies the add-on.","ref":"AshAuthentication.html","title":"AshAuthentication","type":"module"},{"doc":"Find all resources which support authentication for a given OTP application. Returns a list of resource modules. Example iex&gt; authenticated_resources ( :ash_authentication ) [ Example.User ]","ref":"AshAuthentication.html#authenticated_resources/1","title":"AshAuthentication.authenticated_resources/1","type":"function"},{"doc":"Given a subject string, attempt to retrieve a user record. iex&gt; %{ id : user_id } = build_user ( ) ...&gt; { :ok , %{ id : ^ user_id } } = subject_to_user ( &quot;user?id= \#{ user_id } &quot; , Example.User ) Any options passed will be passed to the underlying Api.read/2 callback.","ref":"AshAuthentication.html#subject_to_user/3","title":"AshAuthentication.subject_to_user/3","type":"function"},{"doc":"Return a subject string for user. This is done by concatenating the resource's subject name with the resource's primary key field(s) to generate a uri-like string. Example: iex&gt; build_user ( id : &quot;ce7969f9-afa5-474c-bc52-ac23a103cef6&quot; ) |&gt; user_to_subject ( ) &quot;user?id=ce7969f9-afa5-474c-bc52-ac23a103cef6&quot;","ref":"AshAuthentication.html#user_to_subject/1","title":"AshAuthentication.user_to_subject/1","type":"function"},{"doc":"","ref":"AshAuthentication.html#t:resource_config/0","title":"AshAuthentication.resource_config/0","type":"type"},{"doc":"","ref":"AshAuthentication.html#t:subject/0","title":"AshAuthentication.subject/0","type":"type"},{"doc":"This is an Ash resource extension which generates the default token resource. The token resource is used to store information about tokens that should not be shared with the end user. It does not actually contain any tokens. For example: When an authentication token has been revoked When a confirmation token has changes to apply Storage The information stored in this resource is essentially ephemeral - all tokens have an expiry date, so it doesn't make sense to keep them after that time has passed. However, if you have any tokens with very long expiry times then we suggest you store this resource in a resilient data-layer such as Postgres. Usage There is no need to define any attributes or actions (although you can if you want). The extension will wire up everything that's needed for the token system to function. defmodule MyApp.Accounts.Token do use Ash.Resource , data_layer : AshPostgres.DataLayer , extensions : [ AshAuthentication.TokenResource ] token do api MyApp.Accounts end postgres do table &quot;tokens&quot; repo MyApp.Repo end end Whilst it is possible to have multiple token resources, there is no need to do so. Removing expired records Once a token has expired there's no point in keeping the information it refers to, so expired tokens can be automatically removed by adding the AshAuthentication.Supervisor to your application supervision tree. This will start the AshAuthentication.TokenResource.Expunger GenServer which periodically scans and removes any expired records. Dsl Index token revocation confirmation Docs token Configuration options for this token resource revocation confirmation :api ( atom/0 ) - Required. The Ash API to use to access this resource. :expunge_expired_action_name ( atom/0 ) - The name of the action used to remove expired tokens. The default value is :expunge_expired . :read_expired_action_name ( atom/0 ) - The name of the action use to find all expired tokens. Used internally by the expunge_expired action. The default value is :read_expired . :expunge_interval ( pos_integer/0 ) - How often to remove expired records. How often to scan this resource for records which have expired, and thus can be removed. The default value is 12 . :store_token_action_name ( atom/0 ) - The name of the action to use to store a token. Used it store_all_tokens? is enabled in your authentication resource. The default value is :store_token . revocation Configuration options for token revocation :revoke_token_action_name ( atom/0 ) - The name of the action used to revoke tokens. The default value is :revoke_token . :is_revoked_action_name ( atom/0 ) - The name of the action used to check if a token is revoked. The default value is :revoked? . confirmation Configuration options for confirmation tokens :store_changes_action_name ( atom/0 ) - The name of the action used to store confirmation changes. The default value is :store_confirmation_changes . :get_changes_action_name ( atom/0 ) - The name of the action used to get confirmation changes. The default value is :get_confirmation_changes .","ref":"AshAuthentication.TokenResource.html","title":"AshAuthentication.TokenResource","type":"module"},{"doc":"Remove all expired records.","ref":"AshAuthentication.TokenResource.html#expunge_expired/2","title":"AshAuthentication.TokenResource.expunge_expired/2","type":"function"},{"doc":"Has the token been revoked? Similar to token-revoked?/2..3 except that rather than extracting the JTI from the token, assumes that it's being passed in directly.","ref":"AshAuthentication.TokenResource.html#jti_revoked?/3","title":"AshAuthentication.TokenResource.jti_revoked?/3","type":"function"},{"doc":"Revoke a token. Extracts the JTI from the provided token and uses it to generate a revocationr record.","ref":"AshAuthentication.TokenResource.html#revoke/3","title":"AshAuthentication.TokenResource.revoke/3","type":"function"},{"doc":"Has the token been revoked? Similar to jti_revoked?/2..3 except that it extracts the JTI from the token, rather than relying on it to be passed in.","ref":"AshAuthentication.TokenResource.html#token_revoked?/3","title":"AshAuthentication.TokenResource.token_revoked?/3","type":"function"},{"doc":"An Ash extension which generates the default user identities resource. The user identities resource is used to store information returned by remote authentication strategies (such as those provided by OAuth2) and maps them to your user resource(s). This provides the following benefits: A user can be signed in to multiple authentication strategies at once. For those provides which support it AshAuthentication can handle automatic refreshing of tokens. Storage User identities are expected to be relatively long-lived (although they're deleted on log out), so should probably be stored using a permanent data layer sush as ash_postgres . Usage There is no need to define any attributes, etc. The extension will generate them all for you. As there is no other use-case for this resource it's unlikely that you will need to customise it. defmodule MyApp.Accounts.UserIdentity do use Ash.Resource , data_layer : AshPostgres.DataLayer , extensions : [ AshAuthentication.UserIdentity ] user_identity do api MyApp.Accounts user_resource MyApp.Accounts.User end postgres do table &quot;user_identities&quot; repo MyApp.Repo end end If you intend to operate with multiple user resources, you will need to define multiple user identity resources. Dsl Index user_identity Docs user_identity Configure identity options for this resource :api ( atom/0 ) - Required. The Ash API to use to access this resource. :user_resource ( atom/0 ) - Required. The user resource to which these identities belong. :uid_attribute_name ( atom/0 ) - The name of the uid attribute on this resource. The default value is :uid . :strategy_attribute_name ( atom/0 ) - The name of the strategy attribute on this resource. The default value is :strategy . :user_id_attribute_name ( atom/0 ) - The name of the user_id attribute on this resource. The default value is :user_id . :access_token_attribute_name ( atom/0 ) - The name of the access_token attribute on this resource. The default value is :access_token . :access_token_expires_at_attribute_name ( atom/0 ) - The name of the access_token_expires_at attribute on this resource. The default value is :access_token_expires_at . :refresh_token_attribute_name ( atom/0 ) - The name of the refresh_token attribute on this resource. The default value is :refresh_token . :upsert_action_name ( atom/0 ) - The name of the action used to create and update records. The default value is :upsert . :destroy_action_name ( atom/0 ) - The name of the action used to destroy records. The default value is :destroy . :read_action_name ( atom/0 ) - The name of the action used to query identities. The default value is :read . :user_relationship_name ( atom/0 ) - The name of the belongs-to relationship between identities and users. The default value is :user .","ref":"AshAuthentication.UserIdentity.html","title":"AshAuthentication.UserIdentity","type":"module"},{"doc":"The protocol used for interacting with authentication strategies. Any new Authentication strategy must implement this protocol.","ref":"AshAuthentication.Strategy.html","title":"AshAuthentication.Strategy","type":"protocol"},{"doc":"Perform an named action. Different strategies are likely to implement a number of different actions depending on their configuration. Calling them via this function will ensure that the context is correctly set, etc. See actions/1 for a list of actions provided by the strategy. Any options passed to the action will be passed to the underlying Ash.Api function.","ref":"AshAuthentication.Strategy.html#action/4","title":"AshAuthentication.Strategy.action/4","type":"function"},{"doc":"Return a list of actions supported by the strategy. Example iex&gt; strategy = Info . strategy! ( Example.User , :password ) ...&gt; actions ( strategy ) [ :register , :sign_in , :reset_request , :reset ]","ref":"AshAuthentication.Strategy.html#actions/1","title":"AshAuthentication.Strategy.actions/1","type":"function"},{"doc":"Return the HTTP method for a phase. Example iex&gt; strategy = Info . strategy! ( Example.User , :oauth2 ) ...&gt; method_for_phase ( strategy , :request ) :get","ref":"AshAuthentication.Strategy.html#method_for_phase/2","title":"AshAuthentication.Strategy.method_for_phase/2","type":"function"},{"doc":"Return a list of phases supported by the strategy. Example iex&gt; strategy = Info . strategy! ( Example.User , :password ) ...&gt; phases ( strategy ) [ :register , :sign_in , :reset_request , :reset ]","ref":"AshAuthentication.Strategy.html#phases/1","title":"AshAuthentication.Strategy.phases/1","type":"function"},{"doc":"Handle requests routed to the strategy. Each phase will be an atom (ie the second element in the route tuple). See phases/1 for a list of phases supported by the strategy.","ref":"AshAuthentication.Strategy.html#plug/3","title":"AshAuthentication.Strategy.plug/3","type":"function"},{"doc":"Used to build the routing table to route web requests to request phases for each strategy. Example iex&gt; strategy = Info . strategy! ( Example.User , :password ) ...&gt; routes ( strategy ) [ { &quot;/user/password/register&quot; , :register } , { &quot;/user/password/sign_in&quot; , :sign_in } , { &quot;/user/password/reset_request&quot; , :reset_request } , { &quot;/user/password/reset&quot; , :reset } ]","ref":"AshAuthentication.Strategy.html#routes/1","title":"AshAuthentication.Strategy.routes/1","type":"function"},{"doc":"The name of an individual action supported by the strategy. This maybe not be the action name on the underlying resource, which may be generated, but the name that the strategy itself calls the action.","ref":"AshAuthentication.Strategy.html#t:action/0","title":"AshAuthentication.Strategy.action/0","type":"type"},{"doc":"","ref":"AshAuthentication.Strategy.html#t:http_method/0","title":"AshAuthentication.Strategy.http_method/0","type":"type"},{"doc":"A path to match in web requests","ref":"AshAuthentication.Strategy.html#t:path/0","title":"AshAuthentication.Strategy.path/0","type":"type"},{"doc":"The &quot;phase&quot; of the request. Usually :request or :callback but can be any atom.","ref":"AshAuthentication.Strategy.html#t:phase/0","title":"AshAuthentication.Strategy.phase/0","type":"type"},{"doc":"An individual route. Eg: {&quot;/user/password/sign_in&quot;, :sign_in}","ref":"AshAuthentication.Strategy.html#t:route/0","title":"AshAuthentication.Strategy.route/0","type":"type"},{"doc":"","ref":"AshAuthentication.Strategy.html#t:t/0","title":"AshAuthentication.Strategy.t/0","type":"type"},{"doc":"Strategy for authenticating using an OAuth 2.0 server as the source of truth. This strategy wraps the excellent assent package, which provides OAuth 2.0 capabilities. In order to use OAuth 2.0 authentication on your resource, it needs to meet the following minimum criteria: Have a primary key. Provide a strategy-specific action, either register or sign-in. Provide configuration for OAuth2 destinations, secrets, etc. Example: defmodule MyApp.Accounts.User do use Ash.Resource , extensions : [ AshAuthentication ] attributes do uuid_primary_key :id attribute :email , :ci_string , allow_nil? : false end authentication do api MyApp.Accounts strategies do oauth2 :example do client_id &quot;OAuth Client ID&quot; redirect_uri &quot;https://my.app/&quot; client_secret &quot;My Super Secret Secret&quot; site &quot;https://auth.example.com/&quot; end end end Secrets and runtime configuration In order to use OAuth 2.0 you need to provide a varying number of secrets and other configuration which may change based on runtime environment. The AshAuthentication.Secret behaviour is provided to accomodate this. This allows you to provide configuration either directly on the resource (ie as a string), as an anonymous function, or as a module. Warning We strongly urge you not to sure actual secrets in your code or repository. Examples: Providing configuration as an anonymous function: oauth2 do client_secret fn _path , resource -&gt; Application . fetch_env ( :my_app , resource , :oauth2_client_secret ) end end Providing configuration as a module: defmodule MyApp.Secrets do use AshAuthentication.Secret def secret_for ( [ :authentication , :strategies , :example , :client_secret ] , MyApp.User , _opts ) , do : Application . fetch_env ( :my_app , :oauth2_client_secret ) end # and in your stragegies: oauth2 :example do client_secret MyApp.Secrets end User identities Because your users can be signed in via multiple providers at once, you can specify an identity_resource in the DSL configuration which points to a seperate Ash resource which has the AshAuthentication.UserIdentity extension present. This resource will be used to store details of the providers in use by each user and a relationship will be added to the user resource. Setting the identity_resource will cause extra validations to be applied to your resource so that changes are tracked correctly on sign-in or registration. Actions When using an OAuth 2.0 provider you need to declare either a &quot;register&quot; or &quot;sign-in&quot; action. The reason for this is that it's not possible for us to know ahead of time how you want to manage the link between your user resources and the &quot;user info&quot; provided by the OAuth server. Both actions receive the following two arguments: user_info - a map with string keys containing the OpenID Successful UserInfo response . Usually this will be used to populate your email, nickname or other identifying field. oauth_tokens a map with string keys containing the OpenID Successful Token response (or similar). The actions themselves can be interacted with directly via the AshAuthentication.Strategy protocol, but you are more likely to interact with them via the web/plugs. Sign-in The sign-in action is called when a successful OAuth2 callback is received. You should use it to constrain the query to the correct user based on the arguments provided. This action is only needed when the registration_enabled? DSL settings is set to false . Registration The register action is a little more complicated than the sign-in action, because we cannot tell the difference between a new user and a returning user (they all use the same OAuth flow). In order to handle this your register action must be defined as an upset with a configured upsert_identity (see example below). Examples: Providing sign-in to users who already exist in the database (and by extension rejecting new users): defmodule MyApp.Accounts.User do attributes do uuid_primary_key :id attribute :email , :ci_string , allow_nil? : false end actions do read :sign_in_with_example do argument :user_info , :map , allow_nil? : false argument :oauth_tokens , :map , allow_nil? : false prepare AshAuthentication.Strategy.OAuth2.SignInPreparation filter expr ( email == get_path ( ^ arg ( :user_info ) , [ :email ] ) ) end end authentication do api MyApp.Accounts strategies do oauth2 :example do registration_enabled? false end end end Providing registration or sign-in to all comers: defmodule MyApp.Accounts.User do attributes do uuid_primary_key :id attribute :email , :ci_string , allow_nil? : false end actions do create :register_with_oauth2 do argument :user_info , :map , allow_nil? : false argument :oauth_tokens , :map , allow_nil? : false upsert? true upsert_identity :email change AshAuthentication.GenerateTokenChange change fn changeset , _ctx -&gt; user_info = Ash.Changeset . get_argument ( changeset , :user_info ) changeset |&gt; Changeset . change_attribute ( :email , user_info [ &quot;email&quot; ] ) end end end authentication do api MyApp.Accounts strategies do oauth2 :example do end end end Plugs OAuth 2.0 is (usually) a browser-based flow. This means that you're most likely to interact with this strategy via it's plugs. There are two phases to authentication with OAuth 2.0: The request phase, where the user's browser is redirected to the remote authentication provider for authentication. The callback phase, where the provider redirects the user back to your app to create a local database record, session, etc. DSL Documentation OAuth2 authentication :client_id - Required. The OAuth2 client ID. Takes either a module which implements the AshAuthentication.Secret behaviour, a 2 arity anonymous function or a string. See the module documentation for AshAuthentication.Secret for more information. Example: client_id fn _ , resource -&gt; :my_app |&gt; Application . get_env ( resource , [ ] ) |&gt; Keyword . fetch ( :oauth_client_id ) end :site - Required. The base URL of the OAuth2 server - including the leading protocol (ie https:// ). Takes either a module which implements the AshAuthentication.Secret behaviour, a 2 arity anonymous function or a string. See the module documentation for AshAuthentication.Secret for more information. Example: site fn _ , resource -&gt; :my_app |&gt; Application . get_env ( resource , [ ] ) |&gt; Keyword . fetch ( :oauth_site ) end :auth_method - The authentication strategy used, optional. If not set, no authentication will be used during the access token request. The value may be one of the following: :client_secret_basic :client_secret_post :client_secret_jwt :private_key_jwt The default value is :client_secret_post . :client_secret - The OAuth2 client secret. Required if :auth_method is :client_secret_basic , :client_secret_post or :client_secret_jwt . Takes either a module which implements the AshAuthentication.Secret behaviour, a 2 arity anonymous function or a string. See the module documentation for AshAuthentication.Secret for more information. Example: site fn _ , resource -&gt; :my_app |&gt; Application . get_env ( resource , [ ] ) |&gt; Keyword . fetch ( :oauth_site ) end :authorize_path - The API path to the OAuth2 authorize endpoint. Relative to the value of site . If not set, it defaults to {:ok, &quot;/oauth/authorize&quot;} . Takes either a module which implements the AshAuthentication.Secret behaviour, a 2 arity anonymous function or a string. See the module documentation for AshAuthentication.Secret for more information. Example: authorize_path fn _ , _ -&gt; { :ok , &quot;/authorize&quot; } end :token_path - The API path to access the token endpoint. Relative to the value of site . If not set, it defaults to {:ok, &quot;/oauth/access_token&quot;} . Takes either a module which implements the AshAuthentication.Secret behaviour, a 2 arity anonymous function or a string. See the module documentation for AshAuthentication.Secret for more information. Example: token_path fn _ , _ -&gt; { :ok , &quot;/oauth_token&quot; } end :user_path - The API path to access the user endpoint. Relative to the value of site . If not set, it defaults to {:ok, &quot;/user&quot;} . Takes either a module which implements the AshAuthentication.Secret behaviour, a 2 arity anonymous function or a string. See the module documentation for AshAuthentication.Secret for more information. Example: user_path fn _ , _ -&gt; { :ok , &quot;/userinfo&quot; } end :private_key - The private key to use if :auth_method is :private_key_jwt Takes either a module which implements the AshAuthentication.Secret behaviour, a 2 arity anonymous function or a string. See the module documentation for AshAuthentication.Secret for more information. :redirect_uri - Required. The callback URI base. Not the whole URI back to the callback endpoint, but the URI to your AuthPlug . We can generate the rest. Whilst not particularly secret, it seemed prudent to allow this to be configured dynamically so that you can use different URIs for different environments. Takes either a module which implements the AshAuthentication.Secret behaviour, a 2 arity anonymous function or a string. See the module documentation for AshAuthentication.Secret for more information. :authorization_params ( keyword/0 ) - Any additional parameters to encode in the request phase. eg: authorization_params scope: &quot;openid profile email&quot; The default value is [] . :registration_enabled? ( boolean/0 ) - Is registration enabled for this provider? If this option is enabled, then new users will be able to register for your site when authenticating and not already present. If not, then only existing users will be able to authenticate. The default value is true . :register_action_name ( atom/0 ) - The name of the action to use to register a user. Only needed if registration_enabled? is true . Because we we don't know the response format of the server, you must implement your own registration action of the same name. See the &quot;Registration and Sign-in&quot; section of the module documentation for more information. The default is computed from the strategy name eg: register_with_\#{name} . :sign_in_action_name ( atom/0 ) - The name of the action to use to sign in an existing user. Only needed if registration_enabled? is false . Because we don't know the response format of the server, you must implement your own sign-in action of the same name. See the &quot;Registration and Sign-in&quot; section of the module documentation for more information. The default is computed from the strategy name, eg: sign_in_with_\#{name} . :identity_resource - The resource used to store user identities. Given that a user can be signed into multiple different authentication providers at once we use the AshAuthentication.UserIdentity resource to build a mapping between users, providers and that provider's uid. See the Identities section of the module documentation for more information. Set to false to disable. The default value is false . :identity_relationship_name ( atom/0 ) - Name of the relationship to the provider identities resource The default value is :identities . :identity_relationship_user_id_attribute ( atom/0 ) - The name of the destination (user_id) attribute on your provider identity resource. The only reason to change this would be if you changed the user_id_attribute_name option of the provider identity. The default value is :user_id . :name ( atom/0 ) - Required. Uniquely identifies the strategy.","ref":"AshAuthentication.Strategy.OAuth2.html","title":"AshAuthentication.Strategy.OAuth2","type":"module"},{"doc":"","ref":"AshAuthentication.Strategy.OAuth2.html#t:secret/0","title":"AshAuthentication.Strategy.OAuth2.secret/0","type":"type"},{"doc":"","ref":"AshAuthentication.Strategy.OAuth2.html#t:t/0","title":"AshAuthentication.Strategy.OAuth2.t/0","type":"type"},{"doc":"Strategy for authenticating using local resources as the source of truth. In order to use password authentication your resource needs to meet the following minimum requirements: Have a primary key. A uniquely constrained identity field (eg username or email ). A sensitive string field within which to store the hashed password. There are other options documented in the DSL. Example: defmodule MyApp.Accounts.User do use Ash.Resource , extensions : [ AshAuthentication ] attributes do uuid_primary_key :id attribute :email , :ci_string , allow_nil? : false attribute :hashed_password , :string , allow_nil? : false , sensitive? : true end authentication do api MyApp.Accounts strategies do password :password do identity_field :email hashed_password_field :hashed_password end end end identities do identity :unique_email , [ :email ] end end Actions By default the password strategy will automatically generate the register, sign-in, reset-request and reset actions for you, however you're free to define them yourself. If you do, then the action will be validated to ensure that all the needed configuration is present. If you wish to work with the actions directly from your code you can do so via the AshAuthentication.Strategy protocol. Examples: Interacting with the actions directly: iex&gt; strategy = Info . strategy! ( Example.User , :password ) ...&gt; { :ok , marty } = Strategy . action ( strategy , :register , %{ &quot;username&quot; =&gt; &quot;marty&quot; , &quot;password&quot; =&gt; &quot;outatime1985&quot; , &quot;password_confirmation&quot; =&gt; &quot;outatime1985&quot; } ) ...&gt; marty . username |&gt; to_string ( ) &quot;marty&quot; ...&gt; { :ok , user } = Strategy . action ( strategy , :sign_in , %{ &quot;username&quot; =&gt; &quot;outatime1985&quot; , &quot;password&quot; =&gt; &quot;outatime1985&quot; } ) ...&gt; user . username |&gt; to_string ( ) &quot;marty&quot; Plugs The password strategy provides plug endpoints for all four actions, although only sign-in and register will be reported by Strategy.routes/1 if the strategy is not configured as resettable. If you wish to work with the plugs directly, you can do so via the AshAuthentication.Strategy protocol. Examples: Dispatching to plugs directly: iex&gt; strategy = Info . strategy! ( Example.User , :password ) ...&gt; conn = conn ( :post , &quot;/user/password/register&quot; , %{ &quot;user&quot; =&gt; %{ &quot;username&quot; =&gt; &quot;marty&quot; , &quot;password&quot; =&gt; &quot;outatime1985&quot; , &quot;password_confirmation&quot; =&gt; &quot;outatime1985&quot; } } ) ...&gt; conn = Strategy . plug ( strategy , :register , conn ) ...&gt; { _conn , { :ok , marty } } = Plug.Helpers . get_authentication_result ( conn ) ...&gt; marty . username |&gt; to_string ( ) &quot;marty&quot; ...&gt; conn = conn ( :post , &quot;/user/password/reset_request&quot; , %{ &quot;user&quot; =&gt; %{ &quot;username&quot; =&gt; &quot;marty&quot; } } ) ...&gt; conn = Strategy . plug ( strategy , :reset_request , conn ) ...&gt; { _conn , :ok } = Plug.Helpers . get_authentication_result ( conn ) DSL Documentation Strategy for authenticating using local resources as the source of truth. resettable Examples: password :password do identity_field :email hashed_password_field :hashed_password hash_provider AshAuthentication.BcryptProvider confirmation_required? true end :identity_field ( atom/0 ) - The name of the attribute which uniquely identifies the user. Usually something like username or email_address . The default value is :username . :hashed_password_field ( atom/0 ) - The name of the attribute within which to store the user's password once it has been hashed. The default value is :hashed_password . :hash_provider ( atom/0 ) - A module which implements the AshAuthentication.HashProvider behaviour. Used to provide cryptographic hashing of passwords. The default value is AshAuthentication.BcryptProvider . :confirmation_required? ( boolean/0 ) - Whether a password confirmation field is required when registering or changing passwords. The default value is true . :password_field ( atom/0 ) - The name of the argument used to collect the user's password in plaintext when registering, checking or changing passwords. The default value is :password . :password_confirmation_field ( atom/0 ) - The name of the argument used to confirm the user's password in plaintext when registering or changing passwords. The default value is :password_confirmation . :register_action_name ( atom/0 ) - The name to use for the register action. If not present it will be generated by prepending the strategy name with register_with_ . :sign_in_action_name ( atom/0 ) - The name to use for the sign in action. If not present it will be generated by prependign the strategy name with sign_in_with_ . resettable Configure password reset options for the resource :token_lifetime ( pos_integer/0 ) - How long should the reset token be valid, in hours. Defaults to 3 days. The default value is 72 . :request_password_reset_action_name ( atom/0 ) - The name to use for the action which generates a password reset token. If not present it will be generated by prepending the strategy name with request_password_reset_with_ . :password_reset_action_name ( atom/0 ) - The name to use for the action which actually resets the user's password. If not present it will be generated by prepending the strategy name with password_reset_with_ . :sender - Required. How to send the password reset instructions to the user. Allows you to glue sending of reset instructions to swoosh , ex_twilio or whatever notification system is appropriate for your application. Accepts a module, module and opts, or a function that takes a record, reset token and options. See AshAuthentication.Sender for more information.","ref":"AshAuthentication.Strategy.Password.html","title":"AshAuthentication.Strategy.Password","type":"module"},{"doc":"Generate a reset token for a user. Used by AshAuthentication.Strategy.Password.RequestPasswordResetPreparation .","ref":"AshAuthentication.Strategy.Password.html#reset_token_for/2","title":"AshAuthentication.Strategy.Password.reset_token_for/2","type":"function"},{"doc":"","ref":"AshAuthentication.Strategy.Password.html#t:t/0","title":"AshAuthentication.Strategy.Password.t/0","type":"type"},{"doc":"Confirmation support. Sometimes when creating a new user, or changing a sensitive attribute (such as their email address) you may want to wait for the user to confirm by way of sending them a confirmation token to prove that it was really them that took the action. In order to add confirmation to your resource, it must been the following minimum requirements: Have a primary key Have at least one attribute you wish to confirm Tokens must be enabled Example defmodule MyApp.Accounts.User do use Ash.Resource , extensions : [ AshAuthentication ] attributes do uuid_primary_key :id attribute :email , :ci_string , allow_nil? : false end authentication do api MyApp.Accounts add_ons do confirmation :confirm do monitor_fields [ :email ] end end strategies do # ... end end end Attributes A confirmed_at attribute will be added to your resource if it's not already present (see confirmed_at_field in the DSL documentation). Actions By default confirmation will add an action which updates the confirmed_at attribute as well as retrieving previously stored changes and applying them to the resource. If you wish to perform the confirm action directly from your code you can do so via the AshAuthentication.Strategy protocol. Example iex&gt; strategy = Info . strategy! ( Example.User , :confirm ) ...&gt; { :ok , user } = Strategy . action ( strategy , :confirm , %{ &quot;confirm&quot; =&gt; confirmation_token ( ) } ) ...&gt; user . confirmed_at &gt;= one_second_ago ( ) true Plugs Confirmation provides a single endpoint for the :confirm phase. If you wish to interact with the plugs directly, you can do so via the AshAuthentication.Strategy protocol. Example iex&gt; strategy = Info . strategy! ( Example.User , :confirm ) ...&gt; conn = conn ( :get , &quot;/user/confirm&quot; , %{ &quot;confirm&quot; =&gt; confirmation_token ( ) } ) ...&gt; conn = Strategy . plug ( strategy , :confirm , conn ) ...&gt; { _conn , { :ok , user } } = Plug.Helpers . get_authentication_result ( conn ) ...&gt; user . confirmed_at &gt;= one_second_ago ( ) true DSL Documentation User confirmation flow :token_lifetime ( pos_integer/0 ) - How long should the confirmation token be valid, in hours. Defaults to 3 days. The default value is 72 . :monitor_fields (list of atom/0 ) - Required. A list of fields to monitor for changes (eg [:email, :phone_number] ). The confirmation will only be sent when one of these fields are changed. :confirmed_at_field ( atom/0 ) - The name of a field to store the time that the last confirmation took place. This attribute will be dynamically added to the resource if not already present. The default value is :confirmed_at . :confirm_on_create? ( boolean/0 ) - Generate and send a confirmation token when a new resource is created? Will only trigger when a create action is executed and one of the monitored fields is being set. The default value is true . :confirm_on_update? ( boolean/0 ) - Generate and send a confirmation token when a resource is changed? Will only trigger when an update action is executed and one of the monitored fields is being set. The default value is true . :inhibit_updates? ( boolean/0 ) - Wait until confirmation is received before actually changing a monitored field? If a change to a monitored field is detected, then the change is stored in the token resource and the changeset updated to not make the requested change. When the token is confirmed, the change will be applied. This could be potentially weird for your users, but useful in the case of a user changing their email address or phone number where you want to verify that the new contact details are reachable. The default value is true . :sender - Required. How to send the confirmation instructions to the user. Allows you to glue sending of confirmation instructions to swoosh , ex_twilio or whatever notification system is appropriate for your application. Accepts a module, module and opts, or a function that takes a record, reset token and options. See AshAuthentication.Sender for more information. :confirm_action_name ( atom/0 ) - The name of the action to use when performing confirmation. If this action is not already present on the resource, it will be created for you. The default value is :confirm . :name ( atom/0 ) - Required. Uniquely identifies the add-on.","ref":"AshAuthentication.AddOn.Confirmation.html","title":"AshAuthentication.AddOn.Confirmation","type":"module"},{"doc":"Generate a confirmation token for a changeset. This will generate a token with the &quot;act&quot; claim set to the confirmation action for the strategy, and the &quot;chg&quot; claim will contain any changes.","ref":"AshAuthentication.AddOn.Confirmation.html#confirmation_token/2","title":"AshAuthentication.AddOn.Confirmation.confirmation_token/2","type":"function"},{"doc":"","ref":"AshAuthentication.AddOn.Confirmation.html#t:t/0","title":"AshAuthentication.AddOn.Confirmation.t/0","type":"type"},{"doc":"Provides the default implementation of AshAuthentication.HashProvider using Bcrypt .","ref":"AshAuthentication.BcryptProvider.html","title":"AshAuthentication.BcryptProvider","type":"module"},{"doc":"Given some user input as a string, convert it into it's hashed form using Bcrypt . Example iex&gt; { :ok , hashed } = hash ( &quot;Marty McFly&quot; ) ...&gt; String . starts_with? ( hashed , &quot;$2b$04$&quot; ) true","ref":"AshAuthentication.BcryptProvider.html#hash/1","title":"AshAuthentication.BcryptProvider.hash/1","type":"function"},{"doc":"Simulate a password check to help avoid timing attacks. Example iex&gt; simulate ( ) false","ref":"AshAuthentication.BcryptProvider.html#simulate/0","title":"AshAuthentication.BcryptProvider.simulate/0","type":"function"},{"doc":"Check if the user input matches the hash. Example iex&gt; valid? ( &quot;Marty McFly&quot; , &quot;$2b$04$qgacrnrAJz8aPwaVQiGJn.PvryldV.NfOSYYvF/CZAGgMvvzhIE7S&quot; ) true","ref":"AshAuthentication.BcryptProvider.html#valid?/2","title":"AshAuthentication.BcryptProvider.valid?/2","type":"function"},{"doc":"A behaviour providing password hashing.","ref":"AshAuthentication.HashProvider.html","title":"AshAuthentication.HashProvider","type":"behaviour"},{"doc":"Given some user input as a string, convert it into it's hashed form.","ref":"AshAuthentication.HashProvider.html#c:hash/1","title":"AshAuthentication.HashProvider.hash/1","type":"callback"},{"doc":"Attempt to defeat timing attacks by simulating a password hash check. See Bcrypt.no_user_verify/1 for more information.","ref":"AshAuthentication.HashProvider.html#c:simulate/0","title":"AshAuthentication.HashProvider.simulate/0","type":"callback"},{"doc":"Check if the user input matches the hash.","ref":"AshAuthentication.HashProvider.html#c:valid?/2","title":"AshAuthentication.HashProvider.valid?/2","type":"callback"},{"doc":"Uses the excellent joken hex package to generate and sign Json Web Tokens. Configuration There are a few things we need to know in order to generate and sign a JWT: signing_algorithm - the crypographic algorithm used to to sign tokens. token_lifetime - how long the token is valid for (in hours). signing_secret - the secret key used to sign the tokens. These can be configured in your resource's token DSL: defmodule MyApp.Accounts.User do # ... authentication do tokens do enabled? true token_lifetime 32 signing_secret fn _ , _ -&gt; System . fetch_env ( &quot;TOKEN_SIGNING_SECRET&quot; ) end end end # ... end The signing secret is retrieved using the AshAuthentication.Secret behaviour, which means that it can be retrieved one of three ways: As a string directly in your resource DSL (please don't do this unless you know why this is a bad idea!), or a two-arity anonymous function which returns {:ok, secret} , or the name of a module which implements the AshAuthentication.Secret behaviour. Available signing algorithms are Ed448ph, Ed448, Ed25519ph, Ed25519, PS512, PS384, PS256, ES512, ES384, ES256, RS512, RS384, RS256, HS512, HS384 or HS256. Defaults to HS256. We strongly advise against storing the signing secret in your mix config or directly in your resource configuration. We instead suggest you make use of runtime.exs and read it from the system environment or other secret store. The default token lifetime is 168 and should be specified in integer positive hours.","ref":"AshAuthentication.Jwt.html","title":"AshAuthentication.Jwt","type":"module"},{"doc":"The default signing algorithm","ref":"AshAuthentication.Jwt.html#default_algorithm/0","title":"AshAuthentication.Jwt.default_algorithm/0","type":"function"},{"doc":"The default token lifetime","ref":"AshAuthentication.Jwt.html#default_lifetime_hrs/0","title":"AshAuthentication.Jwt.default_lifetime_hrs/0","type":"function"},{"doc":"Given a token, read it's claims without validating.","ref":"AshAuthentication.Jwt.html#peek/1","title":"AshAuthentication.Jwt.peek/1","type":"function"},{"doc":"Supported signing algorithms","ref":"AshAuthentication.Jwt.html#supported_algorithms/0","title":"AshAuthentication.Jwt.supported_algorithms/0","type":"function"},{"doc":"Given a user, generate a signed JWT for use while authenticating.","ref":"AshAuthentication.Jwt.html#token_for_user/3","title":"AshAuthentication.Jwt.token_for_user/3","type":"function"},{"doc":"Given a token, find a matching resource configuration. Warning This function does not validate the token, so don't rely on it for authentication or authorisation.","ref":"AshAuthentication.Jwt.html#token_to_resource/2","title":"AshAuthentication.Jwt.token_to_resource/2","type":"function"},{"doc":"Given a token, verify it's signature and validate it's claims.","ref":"AshAuthentication.Jwt.html#verify/2","title":"AshAuthentication.Jwt.verify/2","type":"function"},{"doc":"&quot;claims&quot; are the decoded contents of a JWT. A map of (short) string keys to string values.","ref":"AshAuthentication.Jwt.html#t:claims/0","title":"AshAuthentication.Jwt.claims/0","type":"type"},{"doc":"A string likely to contain a valid JWT.","ref":"AshAuthentication.Jwt.html#t:token/0","title":"AshAuthentication.Jwt.token/0","type":"type"},{"doc":"Generate an authentication plug. Use in your app by creating a new module called AuthPlug or similar: defmodule MyAppWeb.AuthPlug do use AshAuthentication.Plug , otp_app : :my_app def handle_success ( conn , _activity , user , _token ) do conn |&gt; store_in_session ( user ) |&gt; send_resp ( 200 , &quot;Welcome back \#{ user . name } &quot; ) end def handle_failure ( conn , _activity , reason ) do conn |&gt; send_resp ( 401 , &quot;Better luck next time&quot; ) end end Using in Phoenix In your Phoenix router you can add it: scope &quot;/auth&quot; do pipe_through :browser forward &quot;/&quot; , MyAppWeb.AuthPlug end In order to load any authenticated users for either web or API users you can add the following to your router: import MyAppWeb.AuthPlug pipeline :session_users do pipe :load_from_session end pipeline :bearer_users do pipe :load_from_bearer end scope &quot;/&quot; , MyAppWeb do pipe_through [ :browser , :session_users ] live &quot;/&quot; , PageLive , :home end scope &quot;/api&quot; , MyAppWeb do pipe_through [ :api , :bearer_users ] get &quot;/&quot; ApiController , :index end Using in a Plug application use Plug.Router forward &quot;/auth&quot; , to : MyAppWeb.AuthPlug Note that you will need to include a bunch of other plugs in the pipeline to do useful things like session and query param fetching.","ref":"AshAuthentication.Plug.html","title":"AshAuthentication.Plug","type":"behaviour"},{"doc":"When there is any failure during authentication this callback is called. Note that this includes not just authentication failures but potentially route-not-found errors also. The default implementation simply returns a 401 status with the message &quot;Access denied&quot;. You almost definitely want to override this.","ref":"AshAuthentication.Plug.html#c:handle_failure/3","title":"AshAuthentication.Plug.handle_failure/3","type":"callback"},{"doc":"When authentication has been succesful, this callback will be called with the conn, the successful activity, the authenticated resource and a token. This allows you to choose what action to take as appropriate for your application. The default implementation calls store_in_session/2 and returns a simple &quot;Access granted&quot; message to the user. You almost definitely want to override this behaviour.","ref":"AshAuthentication.Plug.html#c:handle_success/4","title":"AshAuthentication.Plug.handle_success/4","type":"callback"},{"doc":"","ref":"AshAuthentication.Plug.html#t:activity/0","title":"AshAuthentication.Plug.activity/0","type":"type"},{"doc":"","ref":"AshAuthentication.Plug.html#t:token/0","title":"AshAuthentication.Plug.token/0","type":"type"},{"doc":"Provides the default implementations of handle_success/3 and handle_failure/2 used in generated authentication plugs.","ref":"AshAuthentication.Plug.Defaults.html","title":"AshAuthentication.Plug.Defaults","type":"module"},{"doc":"The default implementation of handle_failure/1 . Sends a very basic 401 response.","ref":"AshAuthentication.Plug.Defaults.html#handle_failure/3","title":"AshAuthentication.Plug.Defaults.handle_failure/3","type":"function"},{"doc":"The default implementation of handle_success/3 . Calls AshAuthentication.Plug.Helpers.store_in_session/2 then sends a basic 200 response.","ref":"AshAuthentication.Plug.Defaults.html#handle_success/4","title":"AshAuthentication.Plug.Defaults.handle_success/4","type":"function"},{"doc":"Route requests and callbacks to the correct provider plugs.","ref":"AshAuthentication.Plug.Dispatcher.html","title":"AshAuthentication.Plug.Dispatcher","type":"module"},{"doc":"Send the request to the correct strategy and then return the result.","ref":"AshAuthentication.Plug.Dispatcher.html#call/2","title":"AshAuthentication.Plug.Dispatcher.call/2","type":"function"},{"doc":"","ref":"AshAuthentication.Plug.Dispatcher.html#t:config/0","title":"AshAuthentication.Plug.Dispatcher.config/0","type":"type"},{"doc":"Authentication helpers for use in your router, etc.","ref":"AshAuthentication.Plug.Helpers.html","title":"AshAuthentication.Plug.Helpers","type":"module"},{"doc":"","ref":"AshAuthentication.Plug.Helpers.html#get_authentication_result/1","title":"AshAuthentication.Plug.Helpers.get_authentication_result/1","type":"function"},{"doc":"Given a list of subjects, turn as many as possible into users.","ref":"AshAuthentication.Plug.Helpers.html#load_subjects/2","title":"AshAuthentication.Plug.Helpers.load_subjects/2","type":"function"},{"doc":"Validate authorization header(s). Assumes that your clients are sending a bearer-style authorization header with your request. If a valid bearer token is present then the subject is loaded into the assigns under their subject name (with the prefix current_ ). If there is no user present for a resource then the assign is set to nil .","ref":"AshAuthentication.Plug.Helpers.html#retrieve_from_bearer/2","title":"AshAuthentication.Plug.Helpers.retrieve_from_bearer/2","type":"function"},{"doc":"Attempt to retrieve all users from the connections' session. Iterates through all configured authentication resources for otp_app and retrieves any users stored in the session, loads them and stores them in the assigns under their subject name (with the prefix current_ ). If there is no user present for a resource then the assign is set to nil .","ref":"AshAuthentication.Plug.Helpers.html#retrieve_from_session/2","title":"AshAuthentication.Plug.Helpers.retrieve_from_session/2","type":"function"},{"doc":"Revoke all authorization header(s). Any bearer-style authorization headers will have their tokens revoked.","ref":"AshAuthentication.Plug.Helpers.html#revoke_bearer_tokens/2","title":"AshAuthentication.Plug.Helpers.revoke_bearer_tokens/2","type":"function"},{"doc":"Set a subject as the request actor. Presumes that you have already loaded your user resource(s) into the connection's assigns. Uses Ash.PlugHelpers to streamline integration with AshGraphql and AshJsonApi . Examples Setting the actor for a AshGraphql API using Plug.Router . defmodule MyApp.ApiRouter do use Plug.Router import MyApp.AuthPlug plug :retrieve_from_bearer plug :set_actor , :user forward &quot;/gql&quot; , to : Absinthe.Plug , init_opts : [ schema : MyApp.Schema ] end","ref":"AshAuthentication.Plug.Helpers.html#set_actor/2","title":"AshAuthentication.Plug.Helpers.set_actor/2","type":"function"},{"doc":"Store result in private. This is used by authentication plug handlers to store their result for passing back to the dispatcher.","ref":"AshAuthentication.Plug.Helpers.html#store_authentication_result/2","title":"AshAuthentication.Plug.Helpers.store_authentication_result/2","type":"function"},{"doc":"Store the user in the connections' session.","ref":"AshAuthentication.Plug.Helpers.html#store_in_session/2","title":"AshAuthentication.Plug.Helpers.store_in_session/2","type":"function"},{"doc":"Generators used within use AshAuthentication.Plug .","ref":"AshAuthentication.Plug.Macros.html","title":"AshAuthentication.Plug.Macros","type":"module"},{"doc":"Generates the load_from_bearer/2 plug with the otp_app prefilled.","ref":"AshAuthentication.Plug.Macros.html#define_load_from_bearer/1","title":"AshAuthentication.Plug.Macros.define_load_from_bearer/1","type":"macro"},{"doc":"Generates the load_from_session/2 plug with the otp_app prefilled.","ref":"AshAuthentication.Plug.Macros.html#define_load_from_session/1","title":"AshAuthentication.Plug.Macros.define_load_from_session/1","type":"macro"},{"doc":"Generates the revoke_bearer_tokens/2 plug with the otp_app prefilled.","ref":"AshAuthentication.Plug.Macros.html#define_revoke_bearer_tokens/1","title":"AshAuthentication.Plug.Macros.define_revoke_bearer_tokens/1","type":"macro"},{"doc":"Generates the subject name validation code for the auth plug.","ref":"AshAuthentication.Plug.Macros.html#validate_subject_name_uniqueness/1","title":"AshAuthentication.Plug.Macros.validate_subject_name_uniqueness/1","type":"macro"},{"doc":"Dynamically generates the authentication router for the authentication requests and callbacks. Used internally by AshAuthentication.Plug .","ref":"AshAuthentication.Plug.Router.html","title":"AshAuthentication.Plug.Router","type":"module"},{"doc":"Actions for the confirmation add-on. Provides the code interface for working with resources via confirmation.","ref":"AshAuthentication.AddOn.Confirmation.Actions.html","title":"AshAuthentication.AddOn.Confirmation.Actions","type":"module"},{"doc":"Attempt to confirm a user.","ref":"AshAuthentication.AddOn.Confirmation.Actions.html#confirm/3","title":"AshAuthentication.AddOn.Confirmation.Actions.confirm/3","type":"function"},{"doc":"Get changes from the tokens resource for application.","ref":"AshAuthentication.AddOn.Confirmation.Actions.html#get_changes/3","title":"AshAuthentication.AddOn.Confirmation.Actions.get_changes/3","type":"function"},{"doc":"Store changes in the tokens resource for later re-use.","ref":"AshAuthentication.AddOn.Confirmation.Actions.html#store_changes/4","title":"AshAuthentication.AddOn.Confirmation.Actions.store_changes/4","type":"function"},{"doc":"Performs a change based on the contents of a confirmation token.","ref":"AshAuthentication.AddOn.Confirmation.ConfirmChange.html","title":"AshAuthentication.AddOn.Confirmation.ConfirmChange","type":"module"},{"doc":"Callback implementation for Ash.Resource.Change.init/1 .","ref":"AshAuthentication.AddOn.Confirmation.ConfirmChange.html#init/1","title":"AshAuthentication.AddOn.Confirmation.ConfirmChange.init/1","type":"function"},{"doc":"Triggers a confirmation flow when one of the monitored fields is changed. Optionally inhibits changes to monitored fields on update.","ref":"AshAuthentication.AddOn.Confirmation.ConfirmationHookChange.html","title":"AshAuthentication.AddOn.Confirmation.ConfirmationHookChange","type":"module"},{"doc":"Callback implementation for Ash.Resource.Change.init/1 .","ref":"AshAuthentication.AddOn.Confirmation.ConfirmationHookChange.html#init/1","title":"AshAuthentication.AddOn.Confirmation.ConfirmationHookChange.init/1","type":"function"},{"doc":"Handlers for incoming OAuth2 HTTP requests.","ref":"AshAuthentication.AddOn.Confirmation.Plug.html","title":"AshAuthentication.AddOn.Confirmation.Plug","type":"module"},{"doc":"Attempt to perform a confirmation.","ref":"AshAuthentication.AddOn.Confirmation.Plug.html#confirm/2","title":"AshAuthentication.AddOn.Confirmation.Plug.confirm/2","type":"function"},{"doc":"DSL transformer for confirmation add-on. Ensures that there is only ever one present and that it is correctly configured.","ref":"AshAuthentication.AddOn.Confirmation.Transformer.html","title":"AshAuthentication.AddOn.Confirmation.Transformer","type":"module"},{"doc":"Callback implementation for Spark.Dsl.Transformer.after_compile?/0 .","ref":"AshAuthentication.AddOn.Confirmation.Transformer.html#after_compile?/0","title":"AshAuthentication.AddOn.Confirmation.Transformer.after_compile?/0","type":"function"},{"doc":"DSL verifier for confirmation add-on.","ref":"AshAuthentication.AddOn.Confirmation.Verifier.html","title":"AshAuthentication.AddOn.Confirmation.Verifier","type":"module"},{"doc":"A generic, authentication failed error.","ref":"AshAuthentication.Errors.AuthenticationFailed.html","title":"AshAuthentication.Errors.AuthenticationFailed","type":"exception"},{"doc":"","ref":"AshAuthentication.Errors.AuthenticationFailed.html#t:t/0","title":"AshAuthentication.Errors.AuthenticationFailed.t/0","type":"type"},{"doc":"An invalid token was presented.","ref":"AshAuthentication.Errors.InvalidToken.html","title":"AshAuthentication.Errors.InvalidToken","type":"exception"},{"doc":"A secret is now missing.","ref":"AshAuthentication.Errors.MissingSecret.html","title":"AshAuthentication.Errors.MissingSecret","type":"exception"},{"doc":"Given a successful registration or sign-in, generate a token.","ref":"AshAuthentication.GenerateTokenChange.html","title":"AshAuthentication.GenerateTokenChange","type":"module"},{"doc":"Callback implementation for Ash.Resource.Change.init/1 .","ref":"AshAuthentication.GenerateTokenChange.html#init/1","title":"AshAuthentication.GenerateTokenChange.init/1","type":"function"},{"doc":"Generated configuration functions based on a resource's DSL configuration.","ref":"AshAuthentication.Info.html","title":"AshAuthentication.Info","type":"module"},{"doc":"authentication.add_ons DSL entities","ref":"AshAuthentication.Info.html#authentication_add_ons/1","title":"AshAuthentication.Info.authentication_add_ons/1","type":"function"},{"doc":"The name of the Ash API to use to access this resource when doing anything authenticaiton related.","ref":"AshAuthentication.Info.html#authentication_api/1","title":"AshAuthentication.Info.authentication_api/1","type":"function"},{"doc":"The name of the Ash API to use to access this resource when doing anything authenticaiton related.","ref":"AshAuthentication.Info.html#authentication_api!/1","title":"AshAuthentication.Info.authentication_api!/1","type":"function"},{"doc":"The name of the read action used to retrieve records. Used internally by AshAuthentication.subject_to_user/2 . If the action doesn't exist, one will be generated for you.","ref":"AshAuthentication.Info.html#authentication_get_by_subject_action_name/1","title":"AshAuthentication.Info.authentication_get_by_subject_action_name/1","type":"function"},{"doc":"The name of the read action used to retrieve records. Used internally by AshAuthentication.subject_to_user/2 . If the action doesn't exist, one will be generated for you.","ref":"AshAuthentication.Info.html#authentication_get_by_subject_action_name!/1","title":"AshAuthentication.Info.authentication_get_by_subject_action_name!/1","type":"function"},{"doc":"authentication DSL options Returns a map containing the and any configured or default values.","ref":"AshAuthentication.Info.html#authentication_options/1","title":"AshAuthentication.Info.authentication_options/1","type":"function"},{"doc":"authentication.strategies DSL entities","ref":"AshAuthentication.Info.html#authentication_strategies/1","title":"AshAuthentication.Info.authentication_strategies/1","type":"function"},{"doc":"The subject name is used anywhere that a short version of your resource name is needed, eg: generating token claims, generating routes, form parameter nesting. This needs to be unique system-wide and if not set will be inferred from the resource name (ie MyApp.Accounts.User will have a subject name of user ).","ref":"AshAuthentication.Info.html#authentication_subject_name/1","title":"AshAuthentication.Info.authentication_subject_name/1","type":"function"},{"doc":"The subject name is used anywhere that a short version of your resource name is needed, eg: generating token claims, generating routes, form parameter nesting. This needs to be unique system-wide and if not set will be inferred from the resource name (ie MyApp.Accounts.User will have a subject name of user ).","ref":"AshAuthentication.Info.html#authentication_subject_name!/1","title":"AshAuthentication.Info.authentication_subject_name!/1","type":"function"},{"doc":"Should JWTs be generated by this resource?","ref":"AshAuthentication.Info.html#authentication_tokens_enabled?/1","title":"AshAuthentication.Info.authentication_tokens_enabled?/1","type":"function"},{"doc":"authentication.tokens DSL options Returns a map containing the and any configured or default values.","ref":"AshAuthentication.Info.html#authentication_tokens_options/1","title":"AshAuthentication.Info.authentication_tokens_options/1","type":"function"},{"doc":"The algorithm to use for token signing. Available signing algorithms are; Ed448ph, Ed448, Ed25519ph, Ed25519, PS512, PS384, PS256, ES512, ES384, ES256, RS512, RS384, RS256, HS512, HS384 and HS256.","ref":"AshAuthentication.Info.html#authentication_tokens_signing_algorithm/1","title":"AshAuthentication.Info.authentication_tokens_signing_algorithm/1","type":"function"},{"doc":"The algorithm to use for token signing. Available signing algorithms are; Ed448ph, Ed448, Ed25519ph, Ed25519, PS512, PS384, PS256, ES512, ES384, ES256, RS512, RS384, RS256, HS512, HS384 and HS256.","ref":"AshAuthentication.Info.html#authentication_tokens_signing_algorithm!/1","title":"AshAuthentication.Info.authentication_tokens_signing_algorithm!/1","type":"function"},{"doc":"The secret used to sign tokens. Takes either a module which implements the AshAuthentication.Secret behaviour, a 2 arity anonymous function or a string. See the module documentation for AshAuthentication.Secret for more information.","ref":"AshAuthentication.Info.html#authentication_tokens_signing_secret/1","title":"AshAuthentication.Info.authentication_tokens_signing_secret/1","type":"function"},{"doc":"The secret used to sign tokens. Takes either a module which implements the AshAuthentication.Secret behaviour, a 2 arity anonymous function or a string. See the module documentation for AshAuthentication.Secret for more information.","ref":"AshAuthentication.Info.html#authentication_tokens_signing_secret!/1","title":"AshAuthentication.Info.authentication_tokens_signing_secret!/1","type":"function"},{"doc":"Store all tokens in the token_resource ? Some applications need to keep track of all tokens issued to any user. This is optional behaviour with ash_authentication in order to preserve as much performance as possible.","ref":"AshAuthentication.Info.html#authentication_tokens_store_all_tokens?/1","title":"AshAuthentication.Info.authentication_tokens_store_all_tokens?/1","type":"function"},{"doc":"How long a token should be valid, in hours. Since refresh tokens are not yet supported, you should probably set this to a reasonably long time to ensure a good user experience. Defaults to 14 days.","ref":"AshAuthentication.Info.html#authentication_tokens_token_lifetime/1","title":"AshAuthentication.Info.authentication_tokens_token_lifetime/1","type":"function"},{"doc":"How long a token should be valid, in hours. Since refresh tokens are not yet supported, you should probably set this to a reasonably long time to ensure a good user experience. Defaults to 14 days.","ref":"AshAuthentication.Info.html#authentication_tokens_token_lifetime!/1","title":"AshAuthentication.Info.authentication_tokens_token_lifetime!/1","type":"function"},{"doc":"The resource used to store token information. If token generation is enabled for this resource, we need a place to store information about tokens, such as revocations and in-flight confirmations.","ref":"AshAuthentication.Info.html#authentication_tokens_token_resource/1","title":"AshAuthentication.Info.authentication_tokens_token_resource/1","type":"function"},{"doc":"The resource used to store token information. If token generation is enabled for this resource, we need a place to store information about tokens, such as revocations and in-flight confirmations.","ref":"AshAuthentication.Info.html#authentication_tokens_token_resource!/1","title":"AshAuthentication.Info.authentication_tokens_token_resource!/1","type":"function"},{"doc":"Retrieve a named strategy from a resource.","ref":"AshAuthentication.Info.html#strategy/2","title":"AshAuthentication.Info.strategy/2","type":"function"},{"doc":"Retrieve a named strategy from a resource (raising version).","ref":"AshAuthentication.Info.html#strategy!/2","title":"AshAuthentication.Info.strategy!/2","type":"function"},{"doc":"Given an action name, retrieve the strategy it is for from the DSL configuration.","ref":"AshAuthentication.Info.html#strategy_for_action/2","title":"AshAuthentication.Info.strategy_for_action/2","type":"function"},{"doc":"Given an action name, retrieve the strategy it is for from the DSL configuration.","ref":"AshAuthentication.Info.html#strategy_for_action!/2","title":"AshAuthentication.Info.strategy_for_action!/2","type":"function"},{"doc":"","ref":"AshAuthentication.Info.html#t:dsl_or_resource/0","title":"AshAuthentication.Info.dsl_or_resource/0","type":"type"},{"doc":"Used to dynamically generate configuration functions for Spark extensions based on their DSL. Usage defmodule MyConfig do use AshAuthentication.InfoGenerator , extension : MyDslExtension , sections : [ :my_section ] end","ref":"AshAuthentication.InfoGenerator.html","title":"AshAuthentication.InfoGenerator","type":"module"},{"doc":"Given an extension and a list of DSL sections generate individual config functions for each option.","ref":"AshAuthentication.InfoGenerator.html#generate_config_functions/2","title":"AshAuthentication.InfoGenerator.generate_config_functions/2","type":"macro"},{"doc":"Given an extension and a list of DSL sections, generate an entities function which returns a list of entities.","ref":"AshAuthentication.InfoGenerator.html#generate_entity_functions/2","title":"AshAuthentication.InfoGenerator.generate_entity_functions/2","type":"macro"},{"doc":"Given an extension and a list of DSL sections, generate an options function which returns a map of all configured options for a resource (including defaults).","ref":"AshAuthentication.InfoGenerator.html#generate_options_functions/2","title":"AshAuthentication.InfoGenerator.generate_options_functions/2","type":"macro"},{"doc":"","ref":"AshAuthentication.InfoGenerator.html#t:options/0","title":"AshAuthentication.InfoGenerator.options/0","type":"type"},{"doc":"Implementation details JWT generation and validation. Provides functions to generate token configuration at runtime, based on the resource being signed for and for verifying claims and checking for token revocation.","ref":"AshAuthentication.Jwt.Config.html","title":"AshAuthentication.Jwt.Config","type":"module"},{"doc":"Generate the default claims for a specified resource.","ref":"AshAuthentication.Jwt.Config.html#default_claims/2","title":"AshAuthentication.Jwt.Config.default_claims/2","type":"function"},{"doc":"The generator function used to generate the &quot;aud&quot; claim. It generates an Elixir-style ~&gt; version requirement against the current major and minor version numbers of AshAuthentication.","ref":"AshAuthentication.Jwt.Config.html#generate_audience/1","title":"AshAuthentication.Jwt.Config.generate_audience/1","type":"function"},{"doc":"The generator function used to generate the &quot;iss&quot; claim.","ref":"AshAuthentication.Jwt.Config.html#generate_issuer/1","title":"AshAuthentication.Jwt.Config.generate_issuer/1","type":"function"},{"doc":"The signer used to sign the token on a per-resource basis.","ref":"AshAuthentication.Jwt.Config.html#token_signer/2","title":"AshAuthentication.Jwt.Config.token_signer/2","type":"function"},{"doc":"The validation function used to validate the &quot;aud&quot; claim. Uses Version.match?/2 to validate the provided claim against the current version. The use of ~&gt; means that tokens generated by versions of AshAuthentication with the the same major version and at least the same minor version should be compatible.","ref":"AshAuthentication.Jwt.Config.html#validate_audience/4","title":"AshAuthentication.Jwt.Config.validate_audience/4","type":"function"},{"doc":"The validation function used to validate the &quot;iss&quot; claim. It simply verifies that the claim starts with &quot;AshAuthentication&quot;","ref":"AshAuthentication.Jwt.Config.html#validate_issuer/3","title":"AshAuthentication.Jwt.Config.validate_issuer/3","type":"function"},{"doc":"The validation function used to the validate the &quot;jti&quot; claim. This is done by checking that the token is valid with the token revocation resource. Requires that the subject's resource configuration be passed as the validation context. This is automatically done by calling Jwt.verify/2 .","ref":"AshAuthentication.Jwt.Config.html#validate_jti/3","title":"AshAuthentication.Jwt.Config.validate_jti/3","type":"function"},{"doc":"A module to implement retrieving of secrets. Allows you to implement secrets access via your method or choice at runtime. Example defmodule MyApp.GetSecret do use AshAuthentication.Secret def secret_for ( [ :authentication , :strategies , :oauth2 , :client_id ] , MyApp.User , _opts ) , do : Application . fetch_env ( :my_app , :oauth_client_id ) def secret_for ( [ :authentication , :strategies , :oauth2 , :client_secret ] , MyApp.User , _opts ) , do : Application . fetch_env ( :my_app , :oauth_client_secret ) end defmodule MyApp.Accounts.User do use Ash.Resource , extensions : [ AshAuthentication ] authentication do api MyApp.Accounts strategies do oauth2 do client_id MyApp.GetSecret client_secret MyApp.GetSecret end end end end You can also implement it directly as a function: defmodule MyApp.User do use Ash.Resource , extensions : [ AshAuthentication ] authentication do api MyApp.Accounts strategies do oauth2 do client_id fn _secret , _resource -&gt; Application . fetch_env ( :my_app , :oauth_client_id ) end end end end end Secret name Because you may wish to reuse this module for a number of different providers and resources, the first argument passed to the callback is the &quot;secret name&quot;, it contains the &quot;path&quot; to the option being set. The path is made up of a list containing the DSL path to the secret.","ref":"AshAuthentication.Secret.html","title":"AshAuthentication.Secret","type":"behaviour"},{"doc":"Secret retrieval callback. This function will be called with the &quot;secret name&quot;, see the module documentation for more info.","ref":"AshAuthentication.Secret.html#c:secret_for/3","title":"AshAuthentication.Secret.secret_for/3","type":"callback"},{"doc":"Implements AshAuthentication.Secret for functions that are provided to the DSL instead of modules.","ref":"AshAuthentication.SecretFunction.html","title":"AshAuthentication.SecretFunction","type":"module"},{"doc":"A module to implement sending of a token to a user. Allows you to glue sending of instructions to swoosh , ex_twilio or whatever notification system is appropriate for your application. Note that the return value and any failures are ignored. If you need retry logic, etc, then you should implement it in your sending system. Example Implementing as a module: defmodule MyApp.PasswordResetSender do use AshAuthentication.PasswordReset.Sender import Swoosh.Email def send ( user , reset_token , _opts ) do new ( ) |&gt; to ( { user . name , user . email } ) |&gt; from ( { &quot;Doc Brown&quot; , &quot;emmet@brown.inc&quot; } ) |&gt; subject ( &quot;Password reset instructions&quot; ) |&gt; html_body ( &quot; &lt;h1&gt;Password reset instructions&lt;/h1&gt; &lt;p&gt; Hi \#{ user . name } ,&lt;br /&gt; Someone (maybe you) has requested a password reset for your account. If you did not initiate this request then please ignore this email. &lt;/p&gt; &lt;a href=&quot; \#{&quot;https://example.com/user/password/reset?\#{URI.encode_query(reset_token: reset_token)}}&quot;&gt; Click here to reset &lt; / a &gt; &quot; ) |&gt; MyApp.Mailer . deliver ( ) end end defmodule MyApp.Accounts.User do use Ash.Resource , extensions : [ AshAuthentication ] authentication do api MyApp.Accounts strategies do password :password do resettable do sender MyApp.PasswordResetSender end end end end end You can also implment it directly as a function: defmodule MyApp.Accounts.User do use Ash.Resource , extensions : [ AshAuthentication ] authentication do api MyApp.Accounts strategies do password :password do resettable do sender fn user , token -&gt; MyApp.Mailer . send_password_reset_email ( user , token ) end end end end end end","ref":"AshAuthentication.Sender.html","title":"AshAuthentication.Sender","type":"behaviour"},{"doc":"Sending callback. This function will be called with the user, the token and any options passed to the module in the DSL.","ref":"AshAuthentication.Sender.html#c:send/3","title":"AshAuthentication.Sender.send/3","type":"callback"},{"doc":"Implements AshAuthentication.Sender for functions that are provided to the DSL instead of modules.","ref":"AshAuthentication.SenderFunction.html","title":"AshAuthentication.SenderFunction","type":"module"},{"doc":"Actions for the oauth2 strategy. Provides the code interface for working with resources via an OAuth2 strategy.","ref":"AshAuthentication.Strategy.OAuth2.Actions.html","title":"AshAuthentication.Strategy.OAuth2.Actions","type":"module"},{"doc":"Attempt to register a new user.","ref":"AshAuthentication.Strategy.OAuth2.Actions.html#register/3","title":"AshAuthentication.Strategy.OAuth2.Actions.register/3","type":"function"},{"doc":"Attempt to sign in a user.","ref":"AshAuthentication.Strategy.OAuth2.Actions.html#sign_in/3","title":"AshAuthentication.Strategy.OAuth2.Actions.sign_in/3","type":"function"},{"doc":"Sets default values for values which can be configured at runtime and are not set.","ref":"AshAuthentication.Strategy.OAuth2.Default.html","title":"AshAuthentication.Strategy.OAuth2.Default","type":"module"},{"doc":"Updates the identity resource when a user is registered.","ref":"AshAuthentication.Strategy.OAuth2.IdentityChange.html","title":"AshAuthentication.Strategy.OAuth2.IdentityChange","type":"module"},{"doc":"Callback implementation for Ash.Resource.Change.init/1 .","ref":"AshAuthentication.Strategy.OAuth2.IdentityChange.html#init/1","title":"AshAuthentication.Strategy.OAuth2.IdentityChange.init/1","type":"function"},{"doc":"Handlers for incoming OAuth2 HTTP requests.","ref":"AshAuthentication.Strategy.OAuth2.Plug.html","title":"AshAuthentication.Strategy.OAuth2.Plug","type":"module"},{"doc":"Perform the callback phase of OAuth2. Responds to a user being redirected back from the remote authentication provider, and validates the passed options, ultimately registering or signing-in a user if the authentication was successful.","ref":"AshAuthentication.Strategy.OAuth2.Plug.html#callback/2","title":"AshAuthentication.Strategy.OAuth2.Plug.callback/2","type":"function"},{"doc":"Perform the request phase of OAuth2. Builds a redirection URL based on the provider configuration and redirects the user to that endpoint.","ref":"AshAuthentication.Strategy.OAuth2.Plug.html#request/2","title":"AshAuthentication.Strategy.OAuth2.Plug.request/2","type":"function"},{"doc":"Prepare a query for sign in Performs three main tasks: Ensures that there is only one matching user record returned, otherwise returns an authentication failed error. Generates an access token if token generation is enabled. Updates the user identity resource, if one is enabled.","ref":"AshAuthentication.Strategy.OAuth2.SignInPreparation.html","title":"AshAuthentication.Strategy.OAuth2.SignInPreparation","type":"module"},{"doc":"Callback implementation for Ash.Resource.Preparation.init/1 .","ref":"AshAuthentication.Strategy.OAuth2.SignInPreparation.html#init/1","title":"AshAuthentication.Strategy.OAuth2.SignInPreparation.init/1","type":"function"},{"doc":"DSL transformer for oauth2 strategies. Iterates through any oauth2 strategies and ensures that all the correct actions and settings are in place.","ref":"AshAuthentication.Strategy.OAuth2.Transformer.html","title":"AshAuthentication.Strategy.OAuth2.Transformer","type":"module"},{"doc":"Callback implementation for Spark.Dsl.Transformer.after_compile?/0 .","ref":"AshAuthentication.Strategy.OAuth2.Transformer.html#after_compile?/0","title":"AshAuthentication.Strategy.OAuth2.Transformer.after_compile?/0","type":"function"},{"doc":"DSL verifier for oauth2 strategies.","ref":"AshAuthentication.Strategy.OAuth2.Verifier.html","title":"AshAuthentication.Strategy.OAuth2.Verifier","type":"module"},{"doc":"Actions for the password strategy Provides the code interface for working with resources via a password strategy.","ref":"AshAuthentication.Strategy.Password.Actions.html","title":"AshAuthentication.Strategy.Password.Actions","type":"module"},{"doc":"Attempt to register a new user.","ref":"AshAuthentication.Strategy.Password.Actions.html#register/3","title":"AshAuthentication.Strategy.Password.Actions.register/3","type":"function"},{"doc":"Attempt to change a user's password using a reset token.","ref":"AshAuthentication.Strategy.Password.Actions.html#reset/3","title":"AshAuthentication.Strategy.Password.Actions.reset/3","type":"function"},{"doc":"Request a password reset.","ref":"AshAuthentication.Strategy.Password.Actions.html#reset_request/3","title":"AshAuthentication.Strategy.Password.Actions.reset_request/3","type":"function"},{"doc":"Attempt to sign in a user.","ref":"AshAuthentication.Strategy.Password.Actions.html#sign_in/3","title":"AshAuthentication.Strategy.Password.Actions.sign_in/3","type":"function"},{"doc":"Set the hash based on the password input. Uses the configured AshAuthentication.HashProvider to generate a hash of the user's password input and store it in the changeset. You can use this change in your actions where you want to change the user's password. If you're not using one of the actions generated by the password strategy then you'll need to manually pass the strategy name in the changeset context. Eg: Changeset . new ( user , %{ } ) |&gt; Changeset . set_context ( %{ strategy_name : :password } ) |&gt; Changeset . for_update ( :update , params ) |&gt; Accounts . update ( ) or by adding it statically to your action definition: update :change_password do change set_context ( %{ strategy_name : :password } ) change AshAuthentication.Strategy.Password.HashPasswordChange end","ref":"AshAuthentication.Strategy.Password.HashPasswordChange.html","title":"AshAuthentication.Strategy.Password.HashPasswordChange","type":"module"},{"doc":"Callback implementation for Ash.Resource.Change.init/1 .","ref":"AshAuthentication.Strategy.Password.HashPasswordChange.html#init/1","title":"AshAuthentication.Strategy.Password.HashPasswordChange.init/1","type":"function"},{"doc":"Validate that the password and password confirmation match. This check is only performed when the confirmation_required? DSL option is set to true . You can use this validation in your own actions where you want to validate that the password and the password confirmation arguments match. If you're not using one of the actions generated by the password strategy then you'll need to manually pass the strategy name in the changeset context. Eg: Changeset . new ( user , %{ } ) |&gt; Changeset . set_context ( %{ strategy_name : :password } ) |&gt; Changeset . for_update ( :change_password , params ) |&gt; Accounts . update ( ) or by adding it statically in your action definition: update :change_password do change set_context ( %{ strategy_name : :password } ) change AshAuthentication.Strategy.Password.HashPasswordChange end","ref":"AshAuthentication.Strategy.Password.PasswordConfirmationValidation.html","title":"AshAuthentication.Strategy.Password.PasswordConfirmationValidation","type":"module"},{"doc":"Callback implementation for Ash.Resource.Validation.init/1 .","ref":"AshAuthentication.Strategy.Password.PasswordConfirmationValidation.html#init/1","title":"AshAuthentication.Strategy.Password.PasswordConfirmationValidation.init/1","type":"function"},{"doc":"Validates that the password and password confirmation fields contain equivalent values - if confirmation is required.","ref":"AshAuthentication.Strategy.Password.PasswordConfirmationValidation.html#validate/2","title":"AshAuthentication.Strategy.Password.PasswordConfirmationValidation.validate/2","type":"function"},{"doc":"Plugs for the password strategy. Handles registration, sign-in and password resets.","ref":"AshAuthentication.Strategy.Password.Plug.html","title":"AshAuthentication.Strategy.Password.Plug","type":"module"},{"doc":"Handle a registration request","ref":"AshAuthentication.Strategy.Password.Plug.html#register/2","title":"AshAuthentication.Strategy.Password.Plug.register/2","type":"function"},{"doc":"Handle a reset request","ref":"AshAuthentication.Strategy.Password.Plug.html#reset/2","title":"AshAuthentication.Strategy.Password.Plug.reset/2","type":"function"},{"doc":"Handle a reset request request","ref":"AshAuthentication.Strategy.Password.Plug.html#reset_request/2","title":"AshAuthentication.Strategy.Password.Plug.reset_request/2","type":"function"},{"doc":"Handle a sign-in request","ref":"AshAuthentication.Strategy.Password.Plug.html#sign_in/2","title":"AshAuthentication.Strategy.Password.Plug.sign_in/2","type":"function"},{"doc":"Prepare a query for a password reset request. This preparation performs three jobs, one before the query executes and two after. Firstly, it constraints the query to match the identity field passed to the action. Secondly, if there is a user returned by the query, then generate a reset token and publish a notification. Always returns an empty result.","ref":"AshAuthentication.Strategy.Password.RequestPasswordResetPreparation.html","title":"AshAuthentication.Strategy.Password.RequestPasswordResetPreparation","type":"module"},{"doc":"Callback implementation for Ash.Resource.Preparation.init/1 .","ref":"AshAuthentication.Strategy.Password.RequestPasswordResetPreparation.html#init/1","title":"AshAuthentication.Strategy.Password.RequestPasswordResetPreparation.init/1","type":"function"},{"doc":"Validate that the token is a valid password reset request token.","ref":"AshAuthentication.Strategy.Password.ResetTokenValidation.html","title":"AshAuthentication.Strategy.Password.ResetTokenValidation","type":"module"},{"doc":"Callback implementation for Ash.Resource.Validation.init/1 .","ref":"AshAuthentication.Strategy.Password.ResetTokenValidation.html#init/1","title":"AshAuthentication.Strategy.Password.ResetTokenValidation.init/1","type":"function"},{"doc":"The entity used to store password reset information.","ref":"AshAuthentication.Strategy.Password.Resettable.html","title":"AshAuthentication.Strategy.Password.Resettable","type":"module"},{"doc":"","ref":"AshAuthentication.Strategy.Password.Resettable.html#t:t/0","title":"AshAuthentication.Strategy.Password.Resettable.t/0","type":"type"},{"doc":"Prepare a query for sign in This preparation performs two jobs, one before the query executes and one after. Firstly, it constrains the query to match the identity field passed to the action. Secondly, it validates the supplied password using the configured hash provider, and if correct allows the record to be returned, otherwise returns an authentication failed error.","ref":"AshAuthentication.Strategy.Password.SignInPreparation.html","title":"AshAuthentication.Strategy.Password.SignInPreparation","type":"module"},{"doc":"Callback implementation for Ash.Resource.Preparation.init/1 .","ref":"AshAuthentication.Strategy.Password.SignInPreparation.html#init/1","title":"AshAuthentication.Strategy.Password.SignInPreparation.init/1","type":"function"},{"doc":"DSL transformer for the password strategy. Iterates through any password authentication strategies and ensures that all the correct actions and settings are in place.","ref":"AshAuthentication.Strategy.Password.Transformer.html","title":"AshAuthentication.Strategy.Password.Transformer","type":"module"},{"doc":"Callback implementation for Spark.Dsl.Transformer.after_compile?/0 .","ref":"AshAuthentication.Strategy.Password.Transformer.html#after_compile?/0","title":"AshAuthentication.Strategy.Password.Transformer.after_compile?/0","type":"function"},{"doc":"DSL verifier for the password strategy.","ref":"AshAuthentication.Strategy.Password.Verifier.html","title":"AshAuthentication.Strategy.Password.Verifier","type":"module"},{"doc":"","ref":"AshAuthentication.Strategy.Password.Verifier.html#transform_strategy/1","title":"AshAuthentication.Strategy.Password.Verifier.transform_strategy/1","type":"function"},{"doc":"Starts and manages any processes required by AshAuthentication. Add to your application supervisor: Example defmodule MyApp.Application do use Application def start ( _type , _args ) do children = [ { AshAuthentication.Supervisor , otp_app : :my_app } ] Supervisor . start_link ( children , strategy : :one_for_one , name : MyApp.Supervisor ) end end","ref":"AshAuthentication.Supervisor.html","title":"AshAuthentication.Supervisor","type":"module"},{"doc":"Returns a specification to start this module under a supervisor. See Supervisor .","ref":"AshAuthentication.Supervisor.html#child_spec/1","title":"AshAuthentication.Supervisor.child_spec/1","type":"function"},{"doc":"The code interface for interacting with the token resource.","ref":"AshAuthentication.TokenResource.Actions.html","title":"AshAuthentication.TokenResource.Actions","type":"module"},{"doc":"Remove all expired records.","ref":"AshAuthentication.TokenResource.Actions.html#expunge_expired/2","title":"AshAuthentication.TokenResource.Actions.expunge_expired/2","type":"function"},{"doc":"Has the token been revoked? Similar to token-revoked?/2..3 except that rather than extracting the JTI from the token, assumes that it's being passed in directly.","ref":"AshAuthentication.TokenResource.Actions.html#jti_revoked?/3","title":"AshAuthentication.TokenResource.Actions.jti_revoked?/3","type":"function"},{"doc":"Revoke a token. Extracts the JTI from the provided token and uses it to generate a revocationr record.","ref":"AshAuthentication.TokenResource.Actions.html#revoke/3","title":"AshAuthentication.TokenResource.Actions.revoke/3","type":"function"},{"doc":"Store a token. Stores a token for any purpose.","ref":"AshAuthentication.TokenResource.Actions.html#store_token/3","title":"AshAuthentication.TokenResource.Actions.store_token/3","type":"function"},{"doc":"Has the token been revoked? Similar to jti_revoked?/2..3 except that it extracts the JTI from the token, rather than relying on it to be passed in.","ref":"AshAuthentication.TokenResource.Actions.html#token_revoked?/3","title":"AshAuthentication.TokenResource.Actions.token_revoked?/3","type":"function"},{"doc":"A GenServer which periodically removes expired token revocations. Scans all token revocation resources based on their configured expunge interval and removes any expired records. defmodule MyApp.Accounts.Token do use Ash.Resource , extensions : [ AshAuthentication.TokenResource ] token do api MyApp.Accounts expunge_interval 12 end end This GenServer is started by the AshAuthentication.Supervisor which should be added to your app's supervision tree.","ref":"AshAuthentication.TokenResource.Expunger.html","title":"AshAuthentication.TokenResource.Expunger","type":"module"},{"doc":"Returns a specification to start this module under a supervisor. See Supervisor .","ref":"AshAuthentication.TokenResource.Expunger.html#child_spec/1","title":"AshAuthentication.TokenResource.Expunger.child_spec/1","type":"function"},{"doc":"Constrains a query to only records which are confirmations that match the jti argument.","ref":"AshAuthentication.TokenResource.GetConfirmationChangesPreparation.html","title":"AshAuthentication.TokenResource.GetConfirmationChangesPreparation","type":"module"},{"doc":"Callback implementation for Ash.Resource.Preparation.init/1 .","ref":"AshAuthentication.TokenResource.GetConfirmationChangesPreparation.html#init/1","title":"AshAuthentication.TokenResource.GetConfirmationChangesPreparation.init/1","type":"function"},{"doc":"Introspection functions for the AshAuthentication.TokenResource Ash extension.","ref":"AshAuthentication.TokenResource.Info.html","title":"AshAuthentication.TokenResource.Info","type":"module"},{"doc":"The Ash API to use to access this resource.","ref":"AshAuthentication.TokenResource.Info.html#token_api/1","title":"AshAuthentication.TokenResource.Info.token_api/1","type":"function"},{"doc":"The Ash API to use to access this resource.","ref":"AshAuthentication.TokenResource.Info.html#token_api!/1","title":"AshAuthentication.TokenResource.Info.token_api!/1","type":"function"},{"doc":"The name of the action used to get confirmation changes.","ref":"AshAuthentication.TokenResource.Info.html#token_confirmation_get_changes_action_name/1","title":"AshAuthentication.TokenResource.Info.token_confirmation_get_changes_action_name/1","type":"function"},{"doc":"The name of the action used to get confirmation changes.","ref":"AshAuthentication.TokenResource.Info.html#token_confirmation_get_changes_action_name!/1","title":"AshAuthentication.TokenResource.Info.token_confirmation_get_changes_action_name!/1","type":"function"},{"doc":"token.confirmation DSL options Returns a map containing the and any configured or default values.","ref":"AshAuthentication.TokenResource.Info.html#token_confirmation_options/1","title":"AshAuthentication.TokenResource.Info.token_confirmation_options/1","type":"function"},{"doc":"The name of the action used to store confirmation changes.","ref":"AshAuthentication.TokenResource.Info.html#token_confirmation_store_changes_action_name/1","title":"AshAuthentication.TokenResource.Info.token_confirmation_store_changes_action_name/1","type":"function"},{"doc":"The name of the action used to store confirmation changes.","ref":"AshAuthentication.TokenResource.Info.html#token_confirmation_store_changes_action_name!/1","title":"AshAuthentication.TokenResource.Info.token_confirmation_store_changes_action_name!/1","type":"function"},{"doc":"The name of the action used to remove expired tokens.","ref":"AshAuthentication.TokenResource.Info.html#token_expunge_expired_action_name/1","title":"AshAuthentication.TokenResource.Info.token_expunge_expired_action_name/1","type":"function"},{"doc":"The name of the action used to remove expired tokens.","ref":"AshAuthentication.TokenResource.Info.html#token_expunge_expired_action_name!/1","title":"AshAuthentication.TokenResource.Info.token_expunge_expired_action_name!/1","type":"function"},{"doc":"How often to remove expired records. How often to scan this resource for records which have expired, and thus can be removed.","ref":"AshAuthentication.TokenResource.Info.html#token_expunge_interval/1","title":"AshAuthentication.TokenResource.Info.token_expunge_interval/1","type":"function"},{"doc":"How often to remove expired records. How often to scan this resource for records which have expired, and thus can be removed.","ref":"AshAuthentication.TokenResource.Info.html#token_expunge_interval!/1","title":"AshAuthentication.TokenResource.Info.token_expunge_interval!/1","type":"function"},{"doc":"token DSL options Returns a map containing the and any configured or default values.","ref":"AshAuthentication.TokenResource.Info.html#token_options/1","title":"AshAuthentication.TokenResource.Info.token_options/1","type":"function"},{"doc":"The name of the action use to find all expired tokens. Used internally by the expunge_expired action.","ref":"AshAuthentication.TokenResource.Info.html#token_read_expired_action_name/1","title":"AshAuthentication.TokenResource.Info.token_read_expired_action_name/1","type":"function"},{"doc":"The name of the action use to find all expired tokens. Used internally by the expunge_expired action.","ref":"AshAuthentication.TokenResource.Info.html#token_read_expired_action_name!/1","title":"AshAuthentication.TokenResource.Info.token_read_expired_action_name!/1","type":"function"},{"doc":"The name of the action used to check if a token is revoked.","ref":"AshAuthentication.TokenResource.Info.html#token_revocation_is_revoked_action_name/1","title":"AshAuthentication.TokenResource.Info.token_revocation_is_revoked_action_name/1","type":"function"},{"doc":"The name of the action used to check if a token is revoked.","ref":"AshAuthentication.TokenResource.Info.html#token_revocation_is_revoked_action_name!/1","title":"AshAuthentication.TokenResource.Info.token_revocation_is_revoked_action_name!/1","type":"function"},{"doc":"token.revocation DSL options Returns a map containing the and any configured or default values.","ref":"AshAuthentication.TokenResource.Info.html#token_revocation_options/1","title":"AshAuthentication.TokenResource.Info.token_revocation_options/1","type":"function"},{"doc":"The name of the action used to revoke tokens.","ref":"AshAuthentication.TokenResource.Info.html#token_revocation_revoke_token_action_name/1","title":"AshAuthentication.TokenResource.Info.token_revocation_revoke_token_action_name/1","type":"function"},{"doc":"The name of the action used to revoke tokens.","ref":"AshAuthentication.TokenResource.Info.html#token_revocation_revoke_token_action_name!/1","title":"AshAuthentication.TokenResource.Info.token_revocation_revoke_token_action_name!/1","type":"function"},{"doc":"The name of the action to use to store a token. Used it store_all_tokens? is enabled in your authentication resource.","ref":"AshAuthentication.TokenResource.Info.html#token_store_token_action_name/1","title":"AshAuthentication.TokenResource.Info.token_store_token_action_name/1","type":"function"},{"doc":"The name of the action to use to store a token. Used it store_all_tokens? is enabled in your authentication resource.","ref":"AshAuthentication.TokenResource.Info.html#token_store_token_action_name!/1","title":"AshAuthentication.TokenResource.Info.token_store_token_action_name!/1","type":"function"},{"doc":"Constrains a query to only records which are revocations that match the token or jti argument.","ref":"AshAuthentication.TokenResource.IsRevokedPreparation.html","title":"AshAuthentication.TokenResource.IsRevokedPreparation","type":"module"},{"doc":"Callback implementation for Ash.Resource.Preparation.init/1 .","ref":"AshAuthentication.TokenResource.IsRevokedPreparation.html#init/1","title":"AshAuthentication.TokenResource.IsRevokedPreparation.init/1","type":"function"},{"doc":"Generates a revocation record for a given token.","ref":"AshAuthentication.TokenResource.RevokeTokenChange.html","title":"AshAuthentication.TokenResource.RevokeTokenChange","type":"module"},{"doc":"Callback implementation for Ash.Resource.Change.init/1 .","ref":"AshAuthentication.TokenResource.RevokeTokenChange.html#init/1","title":"AshAuthentication.TokenResource.RevokeTokenChange.init/1","type":"function"},{"doc":"Populates the JTI based on the token argument.","ref":"AshAuthentication.TokenResource.StoreConfirmationChangesChange.html","title":"AshAuthentication.TokenResource.StoreConfirmationChangesChange","type":"module"},{"doc":"Callback implementation for Ash.Resource.Change.init/1 .","ref":"AshAuthentication.TokenResource.StoreConfirmationChangesChange.html#init/1","title":"AshAuthentication.TokenResource.StoreConfirmationChangesChange.init/1","type":"function"},{"doc":"Stores an arbitrary token.","ref":"AshAuthentication.TokenResource.StoreTokenChange.html","title":"AshAuthentication.TokenResource.StoreTokenChange","type":"module"},{"doc":"Callback implementation for Ash.Resource.Change.init/1 .","ref":"AshAuthentication.TokenResource.StoreTokenChange.html#init/1","title":"AshAuthentication.TokenResource.StoreTokenChange.init/1","type":"function"},{"doc":"The token resource transformer. Sets up the default schema and actions for the token resource.","ref":"AshAuthentication.TokenResource.Transformer.html","title":"AshAuthentication.TokenResource.Transformer","type":"module"},{"doc":"Callback implementation for Spark.Dsl.Transformer.after_compile?/0 .","ref":"AshAuthentication.TokenResource.Transformer.html#after_compile?/0","title":"AshAuthentication.TokenResource.Transformer.after_compile?/0","type":"function"},{"doc":"The token resource verifier.","ref":"AshAuthentication.TokenResource.Verifier.html","title":"AshAuthentication.TokenResource.Verifier","type":"module"},{"doc":"The Authentication transformer Sets up non-provider-specific configuration for authenticated resources.","ref":"AshAuthentication.Transformer.html","title":"AshAuthentication.Transformer","type":"module"},{"doc":"Callback implementation for Spark.Dsl.Transformer.after_compile?/0 .","ref":"AshAuthentication.Transformer.html#after_compile?/0","title":"AshAuthentication.Transformer.after_compile?/0","type":"function"},{"doc":"Code interface for provider identity actions. Allows you to interact with UserIdentity resources without having to mess around with changesets, apis, etc. These functions are delegated to from within AshAuthentication.UserIdentity .","ref":"AshAuthentication.UserIdentity.Actions.html","title":"AshAuthentication.UserIdentity.Actions","type":"module"},{"doc":"Upsert an identity for a user.","ref":"AshAuthentication.UserIdentity.Actions.html#upsert/2","title":"AshAuthentication.UserIdentity.Actions.upsert/2","type":"function"},{"doc":"Introspection functions for the AshAuthentication.UserIdentity Ash extension.","ref":"AshAuthentication.UserIdentity.Info.html","title":"AshAuthentication.UserIdentity.Info","type":"module"},{"doc":"The name of the access_token attribute on this resource.","ref":"AshAuthentication.UserIdentity.Info.html#user_identity_access_token_attribute_name/1","title":"AshAuthentication.UserIdentity.Info.user_identity_access_token_attribute_name/1","type":"function"},{"doc":"The name of the access_token attribute on this resource.","ref":"AshAuthentication.UserIdentity.Info.html#user_identity_access_token_attribute_name!/1","title":"AshAuthentication.UserIdentity.Info.user_identity_access_token_attribute_name!/1","type":"function"},{"doc":"The name of the access_token_expires_at attribute on this resource.","ref":"AshAuthentication.UserIdentity.Info.html#user_identity_access_token_expires_at_attribute_name/1","title":"AshAuthentication.UserIdentity.Info.user_identity_access_token_expires_at_attribute_name/1","type":"function"},{"doc":"The name of the access_token_expires_at attribute on this resource.","ref":"AshAuthentication.UserIdentity.Info.html#user_identity_access_token_expires_at_attribute_name!/1","title":"AshAuthentication.UserIdentity.Info.user_identity_access_token_expires_at_attribute_name!/1","type":"function"},{"doc":"The Ash API to use to access this resource.","ref":"AshAuthentication.UserIdentity.Info.html#user_identity_api/1","title":"AshAuthentication.UserIdentity.Info.user_identity_api/1","type":"function"},{"doc":"The Ash API to use to access this resource.","ref":"AshAuthentication.UserIdentity.Info.html#user_identity_api!/1","title":"AshAuthentication.UserIdentity.Info.user_identity_api!/1","type":"function"},{"doc":"The name of the action used to destroy records.","ref":"AshAuthentication.UserIdentity.Info.html#user_identity_destroy_action_name/1","title":"AshAuthentication.UserIdentity.Info.user_identity_destroy_action_name/1","type":"function"},{"doc":"The name of the action used to destroy records.","ref":"AshAuthentication.UserIdentity.Info.html#user_identity_destroy_action_name!/1","title":"AshAuthentication.UserIdentity.Info.user_identity_destroy_action_name!/1","type":"function"},{"doc":"user_identity DSL options Returns a map containing the and any configured or default values.","ref":"AshAuthentication.UserIdentity.Info.html#user_identity_options/1","title":"AshAuthentication.UserIdentity.Info.user_identity_options/1","type":"function"},{"doc":"The name of the action used to query identities.","ref":"AshAuthentication.UserIdentity.Info.html#user_identity_read_action_name/1","title":"AshAuthentication.UserIdentity.Info.user_identity_read_action_name/1","type":"function"},{"doc":"The name of the action used to query identities.","ref":"AshAuthentication.UserIdentity.Info.html#user_identity_read_action_name!/1","title":"AshAuthentication.UserIdentity.Info.user_identity_read_action_name!/1","type":"function"},{"doc":"The name of the refresh_token attribute on this resource.","ref":"AshAuthentication.UserIdentity.Info.html#user_identity_refresh_token_attribute_name/1","title":"AshAuthentication.UserIdentity.Info.user_identity_refresh_token_attribute_name/1","type":"function"},{"doc":"The name of the refresh_token attribute on this resource.","ref":"AshAuthentication.UserIdentity.Info.html#user_identity_refresh_token_attribute_name!/1","title":"AshAuthentication.UserIdentity.Info.user_identity_refresh_token_attribute_name!/1","type":"function"},{"doc":"The name of the strategy attribute on this resource.","ref":"AshAuthentication.UserIdentity.Info.html#user_identity_strategy_attribute_name/1","title":"AshAuthentication.UserIdentity.Info.user_identity_strategy_attribute_name/1","type":"function"},{"doc":"The name of the strategy attribute on this resource.","ref":"AshAuthentication.UserIdentity.Info.html#user_identity_strategy_attribute_name!/1","title":"AshAuthentication.UserIdentity.Info.user_identity_strategy_attribute_name!/1","type":"function"},{"doc":"The name of the uid attribute on this resource.","ref":"AshAuthentication.UserIdentity.Info.html#user_identity_uid_attribute_name/1","title":"AshAuthentication.UserIdentity.Info.user_identity_uid_attribute_name/1","type":"function"},{"doc":"The name of the uid attribute on this resource.","ref":"AshAuthentication.UserIdentity.Info.html#user_identity_uid_attribute_name!/1","title":"AshAuthentication.UserIdentity.Info.user_identity_uid_attribute_name!/1","type":"function"},{"doc":"The name of the action used to create and update records.","ref":"AshAuthentication.UserIdentity.Info.html#user_identity_upsert_action_name/1","title":"AshAuthentication.UserIdentity.Info.user_identity_upsert_action_name/1","type":"function"},{"doc":"The name of the action used to create and update records.","ref":"AshAuthentication.UserIdentity.Info.html#user_identity_upsert_action_name!/1","title":"AshAuthentication.UserIdentity.Info.user_identity_upsert_action_name!/1","type":"function"},{"doc":"The name of the user_id attribute on this resource.","ref":"AshAuthentication.UserIdentity.Info.html#user_identity_user_id_attribute_name/1","title":"AshAuthentication.UserIdentity.Info.user_identity_user_id_attribute_name/1","type":"function"},{"doc":"The name of the user_id attribute on this resource.","ref":"AshAuthentication.UserIdentity.Info.html#user_identity_user_id_attribute_name!/1","title":"AshAuthentication.UserIdentity.Info.user_identity_user_id_attribute_name!/1","type":"function"},{"doc":"The name of the belongs-to relationship between identities and users.","ref":"AshAuthentication.UserIdentity.Info.html#user_identity_user_relationship_name/1","title":"AshAuthentication.UserIdentity.Info.user_identity_user_relationship_name/1","type":"function"},{"doc":"The name of the belongs-to relationship between identities and users.","ref":"AshAuthentication.UserIdentity.Info.html#user_identity_user_relationship_name!/1","title":"AshAuthentication.UserIdentity.Info.user_identity_user_relationship_name!/1","type":"function"},{"doc":"The user resource to which these identities belong.","ref":"AshAuthentication.UserIdentity.Info.html#user_identity_user_resource/1","title":"AshAuthentication.UserIdentity.Info.user_identity_user_resource/1","type":"function"},{"doc":"The user resource to which these identities belong.","ref":"AshAuthentication.UserIdentity.Info.html#user_identity_user_resource!/1","title":"AshAuthentication.UserIdentity.Info.user_identity_user_resource!/1","type":"function"},{"doc":"The user identity transformer. Sets up the default schema and actions for a user identity resource.","ref":"AshAuthentication.UserIdentity.Transformer.html","title":"AshAuthentication.UserIdentity.Transformer","type":"module"},{"doc":"Callback implementation for Spark.Dsl.Transformer.after_compile?/0 .","ref":"AshAuthentication.UserIdentity.Transformer.html#after_compile?/0","title":"AshAuthentication.UserIdentity.Transformer.after_compile?/0","type":"function"},{"doc":"A change which upserts a user's identity into the user identity resource. Expects the following arguments: user_info a map with string keys as returned from the OAuth2/OpenID upstream provider. oauth_tokens a map with string keys containing the OAuth2 token response. user_id the ID of the user this identity relates to. strategy the name of the strategy. This is usually dynamically inserted into a generated action, however you can add it to your own action if needed.","ref":"AshAuthentication.UserIdentity.UpsertIdentityChange.html","title":"AshAuthentication.UserIdentity.UpsertIdentityChange","type":"module"},{"doc":"Callback implementation for Ash.Resource.Change.init/1 .","ref":"AshAuthentication.UserIdentity.UpsertIdentityChange.html#init/1","title":"AshAuthentication.UserIdentity.UpsertIdentityChange.init/1","type":"function"},{"doc":"The user identity verifier.","ref":"AshAuthentication.UserIdentity.Verifier.html","title":"AshAuthentication.UserIdentity.Verifier","type":"module"},{"doc":"Common validations shared by several transformers.","ref":"AshAuthentication.Validations.html","title":"AshAuthentication.Validations","type":"module"},{"doc":"Find and return a named attribute in the DSL state.","ref":"AshAuthentication.Validations.html#find_attribute/2","title":"AshAuthentication.Validations.find_attribute/2","type":"function"},{"doc":"Build an attribute if not present.","ref":"AshAuthentication.Validations.html#maybe_build_attribute/3","title":"AshAuthentication.Validations.maybe_build_attribute/3","type":"function"},{"doc":"Find and return a persisted option in the DSL state.","ref":"AshAuthentication.Validations.html#persisted_option/2","title":"AshAuthentication.Validations.persisted_option/2","type":"function"},{"doc":"Ensure that the named module implements a specific behaviour.","ref":"AshAuthentication.Validations.html#validate_behaviour/2","title":"AshAuthentication.Validations.validate_behaviour/2","type":"function"},{"doc":"Validates that extension is present on the resource.","ref":"AshAuthentication.Validations.html#validate_extension/2","title":"AshAuthentication.Validations.validate_extension/2","type":"function"},{"doc":"Given a map validate that the provided field is one of the values provided.","ref":"AshAuthentication.Validations.html#validate_field_in_values/3","title":"AshAuthentication.Validations.validate_field_in_values/3","type":"function"},{"doc":"Given a map, validate that the provided field predicate returns true for the value.","ref":"AshAuthentication.Validations.html#validate_field_with/4","title":"AshAuthentication.Validations.validate_field_with/4","type":"function"},{"doc":"Ensure that token generation is enabled for the resource.","ref":"AshAuthentication.Validations.html#validate_token_generation_enabled/1","title":"AshAuthentication.Validations.validate_token_generation_enabled/1","type":"function"},{"doc":"Validation helpers for Resource actions.","ref":"AshAuthentication.Validations.Action.html","title":"AshAuthentication.Validations.Action","type":"module"},{"doc":"Validate an action's argument has an option set to one of the provided values.","ref":"AshAuthentication.Validations.Action.html#validate_action_argument_option/4","title":"AshAuthentication.Validations.Action.validate_action_argument_option/4","type":"function"},{"doc":"Validate that a named action actually exists.","ref":"AshAuthentication.Validations.Action.html#validate_action_exists/2","title":"AshAuthentication.Validations.Action.validate_action_exists/2","type":"function"},{"doc":"Validate the presence of an argument on an action.","ref":"AshAuthentication.Validations.Action.html#validate_action_has_argument/2","title":"AshAuthentication.Validations.Action.validate_action_has_argument/2","type":"function"},{"doc":"Validate the presence of the named change module on an action.","ref":"AshAuthentication.Validations.Action.html#validate_action_has_change/2","title":"AshAuthentication.Validations.Action.validate_action_has_change/2","type":"function"},{"doc":"Validate the presence of the named manual module on an action.","ref":"AshAuthentication.Validations.Action.html#validate_action_has_manual/2","title":"AshAuthentication.Validations.Action.validate_action_has_manual/2","type":"function"},{"doc":"Validate the presence of the named preparation module on an action.","ref":"AshAuthentication.Validations.Action.html#validate_action_has_preparation/2","title":"AshAuthentication.Validations.Action.validate_action_has_preparation/2","type":"function"},{"doc":"Validate the presence of the named validation module on an action.","ref":"AshAuthentication.Validations.Action.html#validate_action_has_validation/2","title":"AshAuthentication.Validations.Action.validate_action_has_validation/2","type":"function"},{"doc":"Validation helpers for Resource attributes.","ref":"AshAuthentication.Validations.Attribute.html","title":"AshAuthentication.Validations.Attribute","type":"module"},{"doc":"Validate that an option is set correctly on an attribute","ref":"AshAuthentication.Validations.Attribute.html#validate_attribute_option/4","title":"AshAuthentication.Validations.Attribute.validate_attribute_option/4","type":"function"},{"doc":"Validate than an attribute has a unique identity applied.","ref":"AshAuthentication.Validations.Attribute.html#validate_attribute_unique_constraint/3","title":"AshAuthentication.Validations.Attribute.validate_attribute_unique_constraint/3","type":"function"},{"doc":"The Authentication verifier.","ref":"AshAuthentication.Verifier.html","title":"AshAuthentication.Verifier","type":"module"},{"doc":"Callback implementation for Spark.Dsl.Transformer.after_compile?/0 .","ref":"AshAuthentication.Verifier.html#after_compile?/0","title":"AshAuthentication.Verifier.after_compile?/0","type":"function"},{"doc":"AshAuthentication provides drop-in support for user authentication for users of the Ash framework . It is designed to be highly configurable, with sensible defaults covering the most common use-cases.","ref":"readme.html","title":"Read Me","type":"extras"},{"doc":"This is beta software. Please don't use it without talking to us!","ref":"readme.html#warning","title":"Read Me - Warning","type":"extras"},{"doc":"The package can be installed by adding ash_authentication to your list of dependencies in mix.exs : def deps do [ { :ash_authentication , &quot;~&gt; 3.3.1&quot; } ] end","ref":"readme.html#installation","title":"Read Me - Installation","type":"extras"},{"doc":"This package assumes that you have Ash installed and configured. See the Ash documentation for details. Once installed you can easily add support for authentication by adding the AshAuthentication extension to your resource: defmodule MyApp.Accounts.User do use Ash.Resource , extensions : [ AshAuthentication ] attributes do uuid_primary_key :id attribute :email , :ci_string , allow_nil? : false attribute :hashed_password , :string , allow_nil? : false , sensitive? : true end authentication do api MyApp.Accounts strategies do password :password do identity_field :email hashed_password_field :hashed_password end end end identities do identity :unique_email , [ :email ] end end If you plan on providing authentication via the web, then you will need to define a plug using AshAuthentication.Plug which builds a Plug.Router that routes incoming authentication requests to the correct provider and provides callbacks for you to manipulate the conn after success or failure. If you're using AshAuthentication with Phoenix, then check out ash_authentication_phoenix which provides route helpers, a controller abstraction and LiveView components for easy set up.","ref":"readme.html#usage","title":"Read Me - Usage","type":"extras"},{"doc":"Currently supported strategies: AshAuthentication.Strategy.Password authenticate users against your local database using a unique identity (such as username or email address) and a password. AshAuthentication.Strategy.OAuth2 authenticate using local or remote OAuth 2.0 compatible services.","ref":"readme.html#authentication-strategies","title":"Read Me - Authentication Strategies","type":"extras"},{"doc":"Documentation for the latest release will be available on hexdocs and for the main branch . Additional support can be found on the GitHub discussions page and the Ash Discord .","ref":"readme.html#documentation","title":"Read Me - Documentation","type":"extras"},{"doc":"To contribute updates, fixes or new features please fork and open a pull-request against main . Please use conventional commits - this allows us to dynamically generate the changelog. Feel free to ask any questions on out GitHub discussions page .","ref":"readme.html#contributing","title":"Read Me - Contributing","type":"extras"},{"doc":"AshAuthentication is licensed under the terms of the MIT license . See the LICENSE file in this repository for details.","ref":"readme.html#licence","title":"Read Me - Licence","type":"extras"},{"doc":"If you haven't already, read the getting started guide for Ash . This assumes that you already have resources set up, and only gives you the steps to add authentication to your resources and APIs.","ref":"getting-started-with-authentication.html","title":"Getting started with Ash Authentication","type":"extras"},{"doc":"Bring in the ash_authentication dependency: # mix.exs defp deps ( ) [ # ... ____mix_dep_ash_authentication____ ] end","ref":"getting-started-with-authentication.html#add-to-your-application-s-dependencies","title":"Getting started with Ash Authentication - Add to your application's dependencies","type":"extras"},{"doc":"Ash Authentication supports many different features, each configured separately. AshAuthentication This is the core extension, and is required. It provides main DSL for working with authentication and related features and should be added to your &quot;user&quot; resource. The {{link:ash_authentication:extension:AshAuthentication| authentication DSL}} provides configuration and sensible defaults for settings which relate to authentication, regardless of authentication mechanism. All strategy and add-on configuration is nested inside this DSL block. It will define a get_by_subject_name read action on your resource, which is used when converting tokens or session information into a resource record. AshAuthentication.Strategy.Password This authentication strategy provides registration and sign-in for users using a local identifier (eg username , email or phone_number ) and a password. It will define register and sign-in actions on your &quot;user&quot; resource. You are welcome to define either or both of these actions yourself if you wish to customise them - if you do so then the extension will do it's best to validate that all required configuration is present. The {{link:ash_authentication:module:AshAuthentication.Strategy.Password| password DSL}} allows you to override any of the default values. AshAuthentication.Strategy.OAuth2 This authentication strategy provides registration and sign-in for users using a remote OAuth 2.0 server as the source of truth. You will be required to provide either a &quot;register&quot; or a &quot;sign-in&quot; action depending on your configuration, which the strategy will attempt to validate for common misconfigurations. AshAuthentication.AddOn.Confirmation This add-on allows you to confirm changes to a user record by generating and sending them a confirmation token which they must submit before allowing the change to take place. AshAuthentication.TokenResource This extension allows you to easily create a resource which will store information about tokens that can't be encoded into the tokens themselves. A resource with this extension must be present if token generation is enabled. AshAuthentication.UserIdentity If you plan to support multiple different strategies at once (eg giving your users the choice of more than one authentication provider, or signing them into multiple services simultaneously) then you will want to create a resource with this extension enabled. It is used to keep track of the links between your local user records and their many remote identities.","ref":"getting-started-with-authentication.html#choosing-your-extensions-strategies-and-add-ons","title":"Getting started with Ash Authentication - Choosing your extensions, strategies and add-ons","type":"extras"},{"doc":"Let's create an Accounts API in our application which provides a User resource and a Token resource. First, let's define our API: # lib/my_app/accounts.ex defmodule MyApp.Accounts do use Ash.Api resources do registry MyApp.Accounts.Registry end end Next, let's define our registry: # lib/my_app/accounts/registry.ex defmodule MyApp.Accounts.Registry do use Ash.Registry , extensions : [ Ash.Registry.ResourceValidations ] entries do entry MyApp.Accounts.User entry MyApp.Accounts.Token end end Next, let's define our Token resource. This resource is needed if token generation is enabled for any resources in your application. Most of the contents are auto-generated, so we just need to provide the data layer configuration and the API to use. You can skip this step if you don't want to use tokens, in which case remove the tokens DSL section in the user resource below. # lib/my_app/accounts/token.ex defmodule MyApp.Accounts.Token do use Ash.Resource , data_layer : AshPostgres.DataLayer , extensions : [ AshAuthentication.TokenResource ] token do api MyApp.Accounts end postgres do table &quot;tokens&quot; repo MyApp.Repo end end Lastly let's define our User resource, using password authentication and token generation enabled. # lib/my_app/accounts/user.ex defmodule MyApp.Accounts.User do use Ash.Resource , data_layer : AshPostgres.DataLayer , extensions : [ AshAuthentication ] attributes do uuid_primary_key :id attribute :email , :ci_string , allow_nil? : false attribute :hashed_password , :string , allow_nil? : false end authentication do api MyApp.Accounts strategies do password :password do identity_field :email end end tokens do enabled? true token_resource MyApp.Accounts.Token signing_secret fn _ , _ -&gt; Application . fetch_env ( :my_app , :token_signing_secret ) end do end postgres do table &quot;users&quot; repo MyApp.Repo end identities do identity :unique_email , [ :email ] end end Here we've added password authentication, using an email address as our identifier. Now we have enough in place to register and sign-in users using the AshAuthentication.Strategy protocol.","ref":"getting-started-with-authentication.html#example","title":"Getting started with Ash Authentication - Example","type":"extras"},{"doc":"If you're using Phoenix, then you can skip this section and go straight to {{link:ash_authentication:guide:integrating-ash-authentication-and-phoenix|Integrating Ash Authentication and Phoenix}} In order for your users to be able to sign in, you will likely need to provide an HTTP endpoint to submit credentials or OAuth requests to. Ash Authentication provides AshAuthentication.Plug for this purposes. It provides a use macro which handles routing of requests to the correct providers, and defines callbacks for successful and unsuccessful outcomes. Let's generate our plug: # lib/my_app/auth_plug.ex defmodule MyApp.AuthPlug do use AshAuthentication.Plug , otp_app : :my_app def handle_success ( conn , _activity , user , token ) if is_api_request? ( conn ) do conn |&gt; send_resp ( 200 , Jason . encode! ( %{ authentication : %{ success : true , token : token } } ) ) else conn |&gt; store_in_session ( user ) |&gt; send_resp ( 200 , EEx . eval_string ( &quot;&quot;&quot; &lt;h2&gt;Welcome back &lt;%= @user.email %&gt;&lt;/h2&gt; &quot;&quot;&quot; , user : user ) ) end end def handle_failure ( conn , _activity , _reason ) do if is_api_request? ( conn ) do conn |&gt; send_resp ( 401 , Jason . encode! ( %{ authentication : %{ success : false } } ) ) else conn |&gt; send_resp ( 401 , &quot;&lt;h2&gt;Incorrect email or password&lt;/h2&gt;&quot; ) end end defp is_api_request? ( conn ) , do : &quot;application/json&quot; in get_req_header ( conn , &quot;accept&quot; ) end Now that this is done, you can forward HTTP requests to it from your app's main router using forward &quot;/auth&quot;, to: MyApp.AuthPlug or similar. Your generated auth plug module will also contain load_from_session and load_from_bearer function plugs, which can be used to load users into assigns based on the contents of the session store or Authorization header.","ref":"getting-started-with-authentication.html#plugs-and-routing","title":"Getting started with Ash Authentication - Plugs and routing","type":"extras"},{"doc":"AshAuthentication includes a supervisor which you should add to your application's supervisor tree. This is used to run any periodic jobs related to your authenticated resources (removing expired tokens, for example). Example defmodule MyApp.Application do use Application def start ( _type , _args ) do children = [ { AshAuthentication.Supervisor , otp_app : :my_app } ] Supervisor . start_link ( childrem , strategy : :one_for_one , name : MyApp.Supervisor ) end end","ref":"getting-started-with-authentication.html#supervisor","title":"Getting started with Ash Authentication - Supervisor","type":"extras"},{"doc":"If you have token generation enabled then you need to provide (at minimum) a signing secret. As the name implies this should be a secret. AshAuthentication provides a mechanism for looking up secrets at runtime using the AshAuthentication.Secret behaviour. To save you a click, this means that you can set your token signing secret using either a static string (please don't!), a two-arity anonymous function, or a module which implements the AshAuthentication.Secret behaviour. At it's simplest you should so something like this: signing_secret fn _ , _ -&gt; Application . fetch_env ( :my_app , :token_signing_secret ) end","ref":"getting-started-with-authentication.html#token-generation","title":"Getting started with Ash Authentication - Token generation","type":"extras"},{"doc":"In this guide we've learned how to install Ash Authentication, configure resources and handle authentication HTTP requests. You should now have an Ash application with working user authentication. Up next, {{link:ash_authentication:guide:getting_started_02_phoenix|Using with Phoenix}}.","ref":"getting-started-with-authentication.html#summary","title":"Getting started with Ash Authentication - Summary","type":"extras"},{"doc":"This guide assumes that you already have an Phoenix application set up with Ash. If you don't then check out the Phoenix topic on Ash HQ . If you haven't already, read {{link:ash_authentication:guide:getting_started_01_basic_setup|Getting started with Ash Authentication}}. This provides a good primer on creating the required resources to use Ash Authentication with your Phoenix app.","ref":"integrating-ash-authentication-and-phoenix.html","title":"Integrating Ash Authentication and Phoenix","type":"extras"},{"doc":"Bring in the ash_authentication_phoenix dependency: # mix.exs defp deps ( ) [ # ... ____mix_dep_ash_authentication_phoenix____ ] end Use mix hex.info ash_authentication_phoenix to quickly find the latest version.","ref":"integrating-ash-authentication-and-phoenix.html#add-to-your-application-s-dependencies","title":"Integrating Ash Authentication and Phoenix - Add to your application's dependencies","type":"extras"},{"doc":"ash_authentication_phoenix includes several helper macros which can generate Phoenix routes for you. They are included by way of a use macro: # lib/my_app_web/router.ex defmodule MyAppWeb.Router do use MyAppWeb , :router use AshAuthentication.Phoenix.Router pipeline :browser do # ... plug ( :load_from_session ) end pipeline :api do # ... plug ( :load_from_bearer ) end scope &quot;/&quot; , MyAppWeb do pipe_through :browser sign_in_route sign_out_route AuthController auth_routes_for MyApp.Accounts.User , to : AuthController end end {{link:ash_authentication_phoenix:function:AshAuthentication.Phoenix.Router.sign_in_route/3| sign_in_route/3 }} This helper generates a live route to the {{link:ash_authentication_phoenix:module:AshAuthentication.Phoenix.SignInLive}} LiveView. This LiveView renders a generic sign-in/register screen. It is entirely optional, and can be customised either by way of {{link:ash_authentication_phoenix:module:AshAuthentication.Phoenix.Overrides|overrides}} or replaced entirely. {{link:ash_authentication_phoenix:function:AshAuthentication.Phoenix.Router.sign_out_route/3| sign_out_route/3 }} This helper generates a route which points to the sign_out action in your AuthController . {{link:ash_authentication_phoenix:function:AshAuthentication.Phoenix.Router.auth_routes_for/2| auth_routes_for/2 }} This helper generates all the required routes for all strategies supported by the provided resource. Generated routes Given the above configuration you should see the following in your routes: # mix phx.routes auth_path * / auth / user / confirm MyAppWeb.AuthController { :user , :confirm , :confirm } auth_path * / auth / user / password / register MyAppWeb.AuthController { :user , :password , :register } auth_path * / auth / user / password / sign_in MyAppWeb.AuthController { :user , :password , :sign_in } auth_path * / auth / user / password / reset_request MyAppWeb.AuthController { :user , :password , :reset_request } auth_path * / auth / user / password / reset MyAppWeb.AuthController { :user , :password , :reset } auth_path * / auth / user / auth0 MyAppWeb.AuthController { :user , :auth0 , :request } auth_path * / auth / user / auth0 / callback MyAppWeb.AuthController { :user , :auth0 , :callback } auth_path GET / sign - in AshAuthentication.Phoenix.SignInLive :sign_in auth_path GET / sign - out MyAppWeb.AuthController :sign_out","ref":"integrating-ash-authentication-and-phoenix.html#link-ash_authentication_phoenix-module-ashauthentication-phoenix-router","title":"Integrating Ash Authentication and Phoenix - {{link:ash_authentication_phoenix:module:AshAuthentication.Phoenix.Router}}","type":"extras"},{"doc":"Instead of using AshAuthentication.Plug as suggested in {{link:ash_authentication:guide:getting_started_01_basic_setup|the previous guide}}, ash_authentication_phoenix comes with a generator which creates a Phoenix.Controller by way of a use macro. All functions in {{link:ash_authentication_phoenix:module:AshAuthentication.Phoenix.Plug}} are automatically imported. You can define multiple versions if required (eg one for your :api pipeline and another for your :browser pipeline). Let's define a version for a browser client: # lib/my_app_web/controllers/auth_controller.ex defmodule MyAppWeb.Controllers.AuthController do use MyAppWeb , :controller use AshAuthentication.Phoenix.Controller def success ( conn , _activity , user , _token ) do return_to = get_session ( conn , :return_to ) || Routes . path_path ( conn , :index ) conn |&gt; delete_session ( :return_to ) |&gt; store_in_session ( user ) |&gt; assign ( :current_user , user ) |&gt; redirect ( to : return_to ) end def failure ( conn , _activity , _reason ) do conn |&gt; put_status ( 401 ) |&gt; render ( &quot;failure.html&quot; ) end def sign_out ( conn , _params ) do return_to = get_session ( conn , :return_to ) || Routes . path_path ( conn , :index ) conn |&gt; clear_session ( ) |&gt; redirect ( to : return_to ) end end success/4 This callback is called when registration or sign-in is successful. You should use it to prepare a response back to the user indicating that authentication was successful. It is called with the following arguments: conn the Plug connection. activity a tuple containing two atoms - the strategy name and the phase. You can use this if you need to provide different behaviour depending on the authentication method. user the authenticated user record (ie an instance of your user resource). token a string containing a JWT for this user, if tokens are enabled. Otherwise nil . In the example above we set up the session to know who the user is on their next request and redirect them to an appropriate location. failure/3 This callback is called when registration or sign-in is unsuccessful. You should use this to render an error, or provide some other indication to the user that authentication has failed. It is called with the following arguments: conn the Plug connection. activity a tuple containing two atoms - the strategy name and the phase. You can use this if you need to provide different behaviour depending on the authentication method. The reason for failure. It could be an Ash.Error , an Ash.Changeset , or any other failure. In the example above we simply set the HTTP status to 401 and render an HTML page. sign_out/2 This is not strictly necessary, but if you have enabled the {{link:ash_authentication_phoenix:function:AshAuthentication.Phoenix.Router.sign_out_route/3| sign_out_route/3 }} helper in your router, then this is the controller action which will be called. Use this to perform any sign-out actions (like clearing the session or {{link:ash_authentication_phoenix:function:AshAuthentication.Phoenix.Plug.revoke_bearer_tokens/2|revoking a token}} and then sending the user on their way.","ref":"integrating-ash-authentication-and-phoenix.html#link-ash_authentication_phoenix-module-ashauthentication-phoenix-controller","title":"Integrating Ash Authentication and Phoenix - {{link:ash_authentication_phoenix:module:AshAuthentication.Phoenix.Controller}}","type":"extras"},{"doc":"ash_authentication_phoenix ships with a number of components allowing you to pick the level of customisation you require. {{link:ash_authentication_phoenix:module:AshAuthentication.Phoenix.Components.SignIn}} This is the top-level component, given a resource configuration it will iterate through all the configured authentication providers and render their UI. You can place this directly into your sign-in page if you want. {{link:ash_authentication_phoenix:module:AshAuthentication.Phoenix.Components.Password}} This component renders the UI for password authentication - both the registration and sign-in UI. {{link:ash_authentication_phoenix:module:AshAuthentication.Phoenix.Components.Password.SignInForm}} This component renders the UI for a password authentication sign-in form. {{link:ash_authentication_phoenix:module:AshAuthentication.Phoenix.Components.Password.RegisterForm}} This component renders the UI for a password authentication registration form. {{link:ash_authentication_phoenix:module:AshAuthentication.Phoenix.Components.Password.ResetForm}} This component renders the UI for a user to request a password reset. {{link:ash_authentication_phoenix:module:AshAuthentication.Phoenix.Components.Password.Input}} This module contains several function components which provide individual input fields and buttons for password authentication. {{link:ash_authentication_phoenix:module:AshAuthentication.Phoenix.Components.OAuth2}} A component which renders a sign-in button for an OAuth 2.0 provider. Overrides All the components above and the {{link:ash_authentication_phoenix:AshAuthentication.Phoenix.SignInLive}} LiveView are customisable via the {{link:ash_authentication_phoenix:AshAuthentication.Phoenix.Overrides}} system. Overrides allow you to configure CSS classes and other options for the components without needing to modify them. Tailwind If you plan on using our default Tailwind -based components without overriding them you will need to modify your assets/tailwind.config.js to include the ash_authentication_phoenix dependency: module.exports = { content: [ // Other paths. &quot;../deps/ash_authentication_phoenix/**/*.ex&quot; ] }","ref":"integrating-ash-authentication-and-phoenix.html#component-library","title":"Integrating Ash Authentication and Phoenix - Component library","type":"extras"},{"doc":"In this guide we've learned how to add Ash Authentication to Phoenix, configure routes and handle authentication.","ref":"integrating-ash-authentication-and-phoenix.html#summary","title":"Integrating Ash Authentication and Phoenix - Summary","type":"extras"}]